/*
* Archivo para manejo general de funciones en el modulo.
*/

// Inicialización de variables a usar en el archivo
var oSubmenu, oGridEm, oWin, baseURL;

// Inicialización de eventos a ejecutar
$(document).ready(
	function () {
		//-- URL base del modulo
		baseURL = $('#dataGrid').attr('base_url');

		regsPage();
	}
);

// Inicializacion del menu y submenu
function regsPage() {
	//-- Inicialización de Submenu
	oSubmenu = new dhtmlXMenuObject("submenu_placeholder", 'dhx_submenu');
	oSubmenu.attachEvent("onClick", submenuClick);
	oSubmenu.loadXML($('#submenu_placeholder').attr('action'));

	//-- Inicialización de Grid
	oGridEm = new dhtmlXGridObject('dataGrid');
	oGridEm.setHeader("NoEmpleado,Nombre,RFC,CURP,NSS,Correo,SalarioBase,SalarioDiario,Antiguedad");
	oGridEm.setInitWidths("106,106,106,106,106,106,106,106,106");
	oGridEm.setColAlign("left,left,left,left,left,left,left,left,left");
	oGridEm.setSkin("dhx_blue");
	oGridEm.attachHeader("#text_filter,#text_filter,#text_filter,#text_filter,#text_filter,#text_filter,#text_filter,#text_filter,#text_filter");
	oGridEm.setColTypes('ro,ro,ro,ro,ro,ro,ro,ro,ro');
//	oGridEm.setHeader("Nombre,RFC,Fecha de alta");
//	oGridEm.setInitWidths("*,150,150");
//	oGridEm.setColAlign("left,left,center");
//	oGridEm.setSkin("dhx_blue");
//	oGridEm.attachHeader("#text_filter,#text_filter,#text_filter");
//	oGridEm.setColTypes('ro,ro,ro');

	oGridEm.init();

	loadGridRowsEm();
}

// Funcion que ejecuta la accion para listar los registros.
function loadGridRowsEm(){
	$.post(
		$('#dataGrid').attr('url'),
		{},
		function (response) {
			oGridEm.clearAll();
			oGridEm.parse(response.data, 'json');
		},
		'json'
	);
}

// Función que carga las acciones correspondientes a la acción seleccionada del submenu
function submenuClick(id_option)
{
	action = oSubmenu.getUserData(id_option, 'script');
	
	if (action != null && action != '') {
		eval(action);
	} else {
		alert('No action specified for ' + id_option);
	}
}

// Función que ejecuta la acción de agregar un registro.
function addRow(id_option)
{
	$.post(
		oSubmenu.getUserData(id_option, 'action'),
		{},
		function (html) {
			oWinEmp = $.newWindow(
				{
					id:'wAddRec', 
					title:'Agregar Empleados',
					height:200,
					width:540,
					content:html,
					modal:true,
					posx: 240,
					posy: 110
				}
			);
			loadJSFile(baseURL + 'batchEmpleados/agregar.js');
			$(".window-closeButton").hide();
		}
	)
}

// Función que ejecuta la acción de editar un registro.
function editRow(id_option)
{
	var id = oGridEm.getSelectedId();
	if (id != null) {
		$.post(
			oSubmenu.getUserData(id_option, 'action'),
			{'id' : id},
			function (html) {
				oWin = $.newWindow(
					{
						id:'wEditRec', 
						title:'Modificar Cliente', 
						height:335,
						width:580, 
						content:html,
						modal:true,
						posx: 240,
						posy: 110
					}
				);	
				loadJSFile(baseURL + 'editar/editar.js');
				$(".window-closeButton").hide();
			}
		);
	} else {
		alert('Debe seleccionar un registro.');
	}
}



// Función que ejecuta la acción de activar/desactivar un registro.
function activarDesactivar(id_option)
{
	var id = oGridEm.getSelectedId();

	if (id != null) {
		if( confirmOperation() ){
			$.post(
				oSubmenu.getUserData(id_option, 'action'),
				{"id" : id},
				function (response) {
						successfulOperation( response.msg );// simple Alerts!
						loadGridRowsEm();
				},
				'json'
			);
		}
	} else {
		alert('Debe seleccionar un registro.');
	}
}
