<?php

/*
 * Genera el Pdf de la factura mediante su id.
 * 
 * @author Mario Cruz.
 */
require_once(FS_FRAMEWORK . 'mpdf/mpdf.php');
require_once(FS_CLASSES . 'NominaDAO.php');
require_once(FS_CLASSES . 'ConfiguracionCuentaDAO.php');
require_once(FS_CLASSES . 'PlantillasDAO.php');
require_once(FS_CLASSES . 'functions.php');

$cta = new ConfiguracionCuentaDAO();
$nom = new NominaDAO();
$oPtlla = new PlantillasDAO();
$result = array();

$id_nomina = (empty($_REQUEST['nId_nomina'])?$id_nomina:$_REQUEST['nId_nomina']);
$infoNomina = $nom->obtenerInformacionNomina($id_nomina);


$infoEmisor = reset($cta->cargaConfiguracionCuenta($infoNomina['id_usuario']));

$nomina = $nom->obtenerInfoTimbrado($id_nomina);


$logotipo = ($infoEmisor['logotipo'] != '' ? FS_DATA_LOGOTIPOS . $infoEmisor['logotipo'] : '');

if (!empty($nomina)) {

	$cbb = file_put_contents(FS_TEMP . "cbb" . $id_nomina . ".jpg", base64_decode($nomina['qrcode']));
	$cbb = '<img class="qr" src="' . FS_TEMP . 'cbb' . $id_nomina . '.jpg" />';

	$mpdf = new mPDF('es-MX', 'Letter');
	$xml = new DOMDocument('1.0', 'utf-8');
	$xml->formatOutput = true;
	$xml->loadXML(utf8_encode($nomina['xml']));

	//-- Informacion del comprobante
	$comprobante = $xml->getElementsByTagName('Comprobante')->item(0);
	$certificado_emisor = $comprobante->getAttribute('noCertificado');
	$serie = $infoNomina['serie'];
	$folio = $infoNomina['folio'];
	$nomina_fecha = $comprobante->getAttribute('fecha');
	$nomina_localidad = $comprobante->getAttribute('LugarExpedicion');
	$metodo_pago = $comprobante->getAttribute('metodoDePago');
	$forma_pago = $comprobante->getAttribute('formaDePago');
	$nomina_subtotal = $comprobante->getAttribute('subTotal');
	if($comprobante->getAttribute('descuento') != ''){
		$nomina_descuentos = $comprobante->getAttribute('descuento');
	}else{
		$nomina_descuentos = '0.0';
	}
	
	$nomina_total = $comprobante->getAttribute('total');
	$total_letra = monedaATexto($nomina_total);
	
	
	//Informacion del emisor
	$emisor = $comprobante->getElementsByTagName('Emisor')->item(0);
	$emisor_nombre = $emisor->getAttribute('nombre');
	$emisor_rfc = $emisor->getAttribute('rfc');
	
	
	$domicilio_emisor = $emisor->getElementsByTagName('DomicilioFiscal')->item(0);
	//-- Domicilio fiscal del emisor
	$emisor_direccion = $domicilio_emisor->getAttribute('calle') . ' '
			. $domicilio_emisor->getAttribute('noExterior') . ' '
			. $domicilio_emisor->getAttribute('noInterior') . ' '
			. $domicilio_emisor->getAttribute('colonia');
	
//-- Regimen fiscal del emisor
	$regimen_emisor = $emisor->getElementsByTagName('RegimenFiscal')->item(0);
	$emisor_regimen = $regimen_emisor->getAttribute('Regimen');

	//Informacion del Receptor
	$receptor = $comprobante->getElementsByTagName('Receptor')->item(0);
	$receptor_rfc = $receptor->getAttribute('rfc');
	$receptor_nombre = $receptor->getAttribute('nombre');

	
	//-- Informacion del Complemento de timbrado fiscal
	$complemento = $comprobante->getElementsByTagName('Complemento')->item(0);
	$complemento_nomina = $complemento->getElementsByTagName('Nomina')->item(0);
	$num_seguridad = $complemento_nomina->getAttribute('NumSeguridadSocial');
	$curp = $complemento_nomina->getAttribute('CURP');
	$tipo_contrato = $complemento_nomina->getAttribute('TipoContrato');
	$num_empleado = $complemento_nomina->getAttribute('NumEmpleado');
	$fecha_contrato = $complemento_nomina->getAttribute('FechaInicioRelLaboral');
	$fecha_ini_pago = $complemento_nomina->getAttribute('FechaInicialPago');
	$fecha_fin_pago = $complemento_nomina->getAttribute('FechaFinalPago');
	$periodicidad_pago = $complemento_nomina->getAttribute('PeriodicidadPago');
	$dias_pagados = $complemento_nomina->getAttribute('NumDiasPagados');
	$registro_patronal = $complemento_nomina->getAttribute('RegistroPatronal');
	$puesto = $complemento_nomina->getAttribute('Puesto');
	$antiguedad = $complemento_nomina->getAttribute('Antiguedad');
	$fecha_pago = $complemento_nomina->getAttribute('FechaPago');
	$tipo_regimen = $complemento_nomina->getAttribute('TipoRegimen');
	$salario_base = $complemento_nomina->getAttribute('SalarioBaseCotApor');
	$salario_diario_integrado = $complemento_nomina->getAttribute('SalarioDiarioIntegrado');
	
	
	$timbre = $complemento->getElementsByTagName('TimbreFiscalDigital')->item(0);
	$certificado_sat = $timbre->getAttribute('noCertificadoSAT');
	$sello_digital_emisor = $timbre->getAttribute('selloCFD');
	$sello_digital_sat = $timbre->getAttribute('selloSAT');
	$fecha_timbrado = $timbre->getAttribute('FechaTimbrado');
	$uuid = $timbre->getAttribute('UUID');
	
	$percepciones = $complemento_nomina->getElementsByTagName('Percepciones')->item(0);
	$tPercepcionEx = $percepciones->getAttribute('TotalExento');
	$tPercepcionGr = $percepciones->getAttribute('TotalGravado');
	
	$total_exento_per =  pesos((!empty($tPercepcionEx)?$tPercepcionEx:0.0));
	$total_gravado_per = pesos((!empty($tPercepcionGr)?$tPercepcionGr:0.0));
	
	if($complemento_nomina->getElementsByTagName('Deducciones')->item(0) > 0){
		$deducciones = $complemento_nomina->getElementsByTagName('Deducciones')->item(0);
		$total_exento_ded = pesos($deducciones->getAttribute('TotalExento'));
		$total_gravado_ded = pesos($deducciones->getAttribute('TotalGravado'));
	}else{
		$total_exento_ded = pesos(0.0);
		$total_gravado_ded = pesos(0.0);
	}
	
	$impuestos = $comprobante->getElementsByTagName('Impuestos')->item(0);
	$retenciones = $impuestos->getElementsByTagName('Retenciones')->item(0);
	$retenciones = $retenciones->getElementsByTagName('Retencion')->item(0);
	$retencion = $retenciones->getAttribute('importe');
	$plantilla = reset($oPtlla->plantillaComprobante($infoNomina['id_usuario'], 4));
	$oTpl->loadFromString(utf8_encode($plantilla['html']));
	
	$oTpl->setVar(
			array(
				'EMISOR_NOMBRE' => $emisor_nombre,
				'EMISOR_DIRECCION' => $emisor_direccion,
				'EMISOR_RFC' => $emisor_rfc,
				'EMISOR_REGIMEN' => $emisor_regimen,
				'RECEPTOR_RAZON_SOCIAL' => $receptor_nombre,
				'RECEPTOR_RFC' => $receptor_rfc,
				'SERIE_FOLIO' => trim($serie . ' ' . $folio),
				'NOMINA_FECHA' => $nomina_fecha,
				'NOMINA_LUGAR_EXPEDICION' => $nomina_localidad,
				'METODO_PAGO' => $metodo_pago,
				'FORMA_PAGO' => $forma_pago,
				'NOMINA_SUBTOTAL' => pesos($nomina_subtotal),
				'NOMINA_DESCUENTOS' => pesos($nomina_descuentos),
				'NOMINA_ISR' => pesos($retencion),
				'NOMINA_TOTAL' => pesos($nomina_total),
				'CERTIFICADO_SAT' => $certificado_sat,
				'CERTIFICADO_EMISOR' => $certificado_emisor,
				'FECHA_CERTIFICADO' => $fecha_timbrado,
				'FOLIO_FISCAL' => $uuid,
				'CADENA_ORIGINAL' => $nomina['cadena_timbre'],
				'SELLO_DIGITAL_EMISOR' => $sello_digital_emisor,
				'SELLO_DIGITAL_SAT' => $sello_digital_sat,
				'IMG_CCB' => $cbb,
				'TOTAL_LETRA' => $total_letra,
				'LOGOTIPO' => $logotipo,
				'LOGO_X' => $infoEmisor['pos_x'] . 'px',
				'LOGO_Y' => $infoEmisor['pos_y'] . 'px',
				'LOGO_W' => $infoEmisor['ancho'] . 'px',
				'LOGO_H' => $infoEmisor['alto'] . 'px',
				'EMISOR_X' => $infoEmisor['margen_datos_emisor'] . 'px',
				'IMAGENES_PLANTILLAS' => FS_IMAGENES_PLANTILLAS,
				'NUM_EMPLEADO' => $num_empleado,
				'RECEPTOR_NSS' => $num_seguridad,
				'RECEPTOR_CURP' => $curp,
				'TIPO_CONTRATO' => $tipo_contrato,
				'FECHA_CONTRATO' => $fecha_contrato,
				'PERIODICIDAD_PAGO' => $periodicidad_pago,
				'FECHA_INICIO_PAGO' => $fecha_ini_pago,
				'FECHA_FINAL_PAGO' => $fecha_fin_pago,
				'DIAS_PAGADOS' => $dias_pagados,
				'FECHA_PAGO' => $fecha_pago,
				'REGISTRO_PATRONAL' => $registro_patronal,
				'PUESTO' => $puesto,
				'ANTIGUEDAD' => $antiguedad,
				'REGIMEN_CONTRATACION' => $tipo_regimen,
				'SALARIO_BASE'=> $salario_base,
				'SALARIO_DIARIO_INTEGRADO'=> $salario_diario_integrado,
				'TOTAL_IMPORTE_GRAVADO_PER' => $total_gravado_per,
				'TOTAL_IMPORTE_EXENTO_PER' => $total_exento_per,
				'TOTAL_IMPORTE_GRAVADO_DED' => $total_gravado_ded,
				'TOTAL_IMPORTE_EXENTO_DED' => $total_exento_ded
			)
	);

	//-- Elimina block de logotipo si no se ha configurado la imagen
	$oTpl->removeBlock('LOGOTIPO', empty($logotipo));

	//-- Procesa Información de Percepciones
	$percepciones = $complemento_nomina->getElementsByTagName('Percepciones');
	if ($oTpl->getBlock('DETALLE_CONCEPTOS_PERCEPCIONES')) {
		foreach ($percepciones as $pr) {
			$lista_percepciones = $pr->getElementsByTagName('Percepcion');
			foreach ($lista_percepciones as $rs) {
				$concepto = str_replace(chr(13) . chr(10), '<br>', $rs->getAttribute('Concepto'));
				$oTpl->setVar(
						array(
							'TIPO_PERCEPCION' => $rs->getAttribute('TipoPercepcion'),
							'CLAVE_PER' => $rs->getAttribute('Clave'),
							'CONCEPTO_PER' => $concepto,
							'IMPORTE_GRAVADO_PER' => pesos($rs->getAttribute('ImporteGravado')),
							'IMPORTE_EXENTO_PER' => pesos($rs->getAttribute('ImporteExento'))
						)
				);
				$oTpl->appendBlock();
			}
		}

		$oTpl->putBlock('DETALLE_CONCEPTOS_PERCEPCIONES');
	}
	
	

	//-- Procesa Información de Deducciones
	if ($complemento_nomina->getElementsByTagName('Deducciones')->length > 0){
	$deducciones = $complemento_nomina->getElementsByTagName('Deducciones');
	if ($oTpl->getBlock('DETALLE_CONCEPTOS_DEDUCCIONES')) {
		foreach ($deducciones as $de) {
			$lista_deducciones = $de->getElementsByTagName('Deduccion');
			foreach ($lista_deducciones as $rs) {
				$concepto = str_replace(chr(13) . chr(10), '<br>', $rs->getAttribute('Concepto'));
				$oTpl->setVar(
						array(
							'TIPO_DEDUCCION' => $rs->getAttribute('TipoDeduccion'),
							'CLAVE_DED' => $rs->getAttribute('Clave'),
							'CONCEPTO_DED' => $concepto,
							'IMPORTE_GRAVADO_DED' => ($rs->getAttribute('ImporteGravado')),
							'IMPORTE_EXENTO_DED' => ($rs->getAttribute('ImporteExento'))
						)
				);
				$oTpl->appendBlock();
			}
		}

		$oTpl->putBlock('DETALLE_CONCEPTOS_DEDUCCIONES');
	}
	}
	

	//-- Extraemos plantilla procesada
	$strPDF = utf8_decode($oTpl->publish(true));

	$mpdf->WriteHTML($plantilla['css'], 1);
	$mpdf->WriteHTML($strPDF, 0);
	if (!file_exists(FS_TEMP))
		mkdir(FS_TEMP);

	$name = 'nomina_' . trim($serie . $folio) . '.pdf';
	$mpdf->Output(FS_TEMP . $name, 'F');

	$oTpl->load(FS_ADMON_NOMINA . 'nomina/imprimir/nominaHtml.html');
	$oTpl->setVar(array('DOCUMENT_SOURCE' => WS_FRAMEWORK . 'downloadPdf.php?pdf=' . $name));

	$result['timbrada'] = 1;
	$result['html'] = $oTpl->publish(true);
	$result['name_file'] = $name;
}else {
	$result['timbrada'] = 0;
}

if (isset($enviar)) {
	return json_encode($result);
} else {
	if(file_exists(FS_TEMP . "cbb" . $id_nomina . ".jpg"))
	unlink(FS_TEMP . "cbb" . $id_nomina . ".jpg");
	echo json_encode($result);
}
?>