<?php

require_once('./nusoap/nusoap.php');
require_once (FS_CLASSES . 'genera_nomina_xml.php');
require_once(FS_CLASSES . 'NominaDAO.php');
require_once(FS_CLASSES . 'FolioDAO.php');
require_once(FS_CLASSES . 'ConfWsdlDAO.php');
require_once(FS_CLASSES . 'PaqueteDAO.php');

$urlWsdl = new ConfWsdlDAO();
$timbradoWsdl = $urlWsdl->getConfigWsdl();

$client = new nusoap_client($timbradoWsdl['timbrado'], true);

$err = $client->getError();
if ($err) {
	die('<h2>Constructor error</h2><pre>' . $err . '</pre>');
}
$nom = new NominaDAO();
$fecha_corte = $_POST['fecha_corte'];

ini_set('max_execution_time', 0);
//Se obtiene la informacion del corte
$list_nomina = $nom->listaNomina($fecha_corte, 1);
$mensaje = "";
$timbrados = 0;
$pendientes = count($list_nomina);


if (!empty($list_nomina)) {
	foreach ($list_nomina as $nomina) {
		$id_nomina = $nomina['id_nomina'];
		if ($nomina['cancelada'] == 0) {
			if (empty($nomina['uuid'])) {
				//Se verifica que el usuario cuente con un paquete activo
				$info_paquete = new PaqueteDAO();
				$paquete_usuario = $info_paquete->getPaqueteCuenta($_SESSION['user']->id_usuario);
				if ($paquete_usuario['restantes'] > 0) {

					//-- Recupera 
					$folio = $nom->getFolioNomina($id_nomina);
					//-- Verifica si factura ya tiene folio y series asignados o es necesario asignar un nuevo folio
					if (intval($folio['folio']) <= 0) {
						//-- Asignacion de Serie y Folio para factura si aun no tiene folio
						$oFolio = new FolioDAO();
						
						
						$tipoNomina = 4;  //TIPO COMPROBANTE NOMINA
						$folio = $oFolio->asigaFolioComprobante($_SESSION['user']->id_usuario, $tipoNomina);
					}
					
					//-- Valida que se haya obtenido un folio y serie para la factura
					if ($folio != null) {
						//-- Actualizar la serie y folio para la factura
						$nom->updateFolioNomina($id_nomina, $folio['serie'], $folio['folio']);
						
						//Se genera el archivo XML con la informacion de la factura.
						$obj = new genera_xml();
						$res = $obj->xmlNomina($id_nomina);
												
						$xml = $res[0]['xml'];
						$rfc = $res[0]['rfc_emisor'];
						
						$nomina_service = array(
							'xml' => $xml,
							'rfc' => $rfc
						);
						
						$result = $client->call('timbradoCFDi', array('in' => $nomina_service));
						
						
						if ($client->fault) {
							$mensaje .= "\n\nPor el momento no esta disponible el servicio de timbrado.";
						} else {
							$err = $client->getError();
							if ($err) {
							$mensaje .= "\n\nPor el momento no esta disponible el servicio de timbrado.";
							} else {
								//Se guarda la informacion del timbrado.
								if ($result['result'] == 0) {
									$timbrados++;
									$data['nId_factura'] = $res[0]['id_factura'];
									$data['sUuid'] = $result['uuid'];
									$data['tCadena_timbre'] = $result['cadena_timbre'];
									$data['bQrcode'] = $result['qrcode'];
									$data['tXml'] = ($result['xml']);
									$data['dFecha_timbrado'] = $result['fecha_timbrado'];
									$data['sNomina'] = 1;
									
									$nom->insTimbrado($data);
									//Se actualiza la cantidad de timbres disponibles para el usuario.
									$info_paquete->updPaqueteCuenta($_SESSION['user']->id_usuario);
								}else{
									$mensaje .= "\n\nNo se timbro el recibo del empleado No. ".$nomina['id_empleado']."\n"
											. $result['message'];
								}
							}
						}
					} else {
					$mensaje .= "\n\nNo se timbro el recibo del empleado No. ".$nomina['id_empleado']."\n"
							."No se ha configurado la serie y folio para este tipo de comprobante.";
					}
				} else {
					$mensaje .= "\n\nNo se timbro el recibo del empleado No. ".$nomina['id_empleado']."\n"
							."No cuenta con un paquete de timbres disponible.";
				}
			}
		}
	}
}
$result['message'] = "Se generaron ".$timbrados." de ".$pendientes." recibos pendientes. ".$mensaje;
echo json_encode_utf8($result);
?>