/*
* Archivo para manejo general de funciones en el modulo.
*/

// Inicialización de variables a usar en el archivo
var oSubmenu, oGrid, oWin, baseURL;

// Inicialización de eventos a ejecutar
$(document).ready(
	function () {
		//-- URL base del modulo
		baseURL = $('#dataGrid').attr('base_url');

		regsPage();
	}
	);

// Inicializacion del menu y submenu
function regsPage(){
	//-- Inicialización de Submenu
	oSubmenu = new dhtmlXMenuObject("submenu_placeholder", 'dhx_submenu');
	oSubmenu.attachEvent("onClick", submenuClick);
	oSubmenu.loadXML($('#submenu_placeholder').attr('action'));
		
	//-- Inicialización de Grid
	oGrid = new dhtmlXGridObject('dataGrid');
	oGrid.setHeader("Id,Nombre,Descripci&oacuten");
	oGrid.setInitWidths("50,160,*");
	oGrid.setColAlign("center,left,left");
	oGrid.setSkin("dhx_blue");
	oGrid.attachHeader("#text_filter,#text_filter,#text_filter");
	oGrid.setColTypes('ro,ro,ro');

	oGrid.init();

	loadGridRows();
}

// Funcion que ejecuta la accion para listar los registros.
function loadGridRows()
{
	$.post(
		$('#dataGrid').attr('url'),
		{},
		function (response) {
			oGrid.clearAll();
			oGrid.parse(response.data, 'json');
		},
		'json'
		);
}

// Función que carga las acciones correspondientes a la acción seleccionada del submenu
function submenuClick(id_option)
{
	action = oSubmenu.getUserData(id_option, 'script');
	
	if (action != null && action != '') {
		eval(action);
	} else {
		alert('No action specified for ' + id_option);
	}
}

function addRow(id_option)
{
	$.post(
		oSubmenu.getUserData(id_option, 'action'),
		{},
		function (html) {
			loadJSFile(baseURL + 'agregar/agregar.js');
			oWin = $.newWindow(
			{
				id:'wAddRec', 
				title:'Agregar Unidad de Medida', 
				height:150, 
				width:630, 
				content:html,
				modal:true,
				posx: 120,
				posy: 70,
				onWindowClose: 
				function(){
					loadGridRows();
				}
			}
			);				
		}
		)
}

function editRow(id_option)
{
	var id = oGrid.getSelectedId();
	if(id != null){
		$.post(
			oSubmenu.getUserData(id_option, 'action'),
			{
				id : id
			},
			function (html) {
				loadJSFile(baseURL + 'editar/editar.js');
				oWin = $.newWindow(
				{
					id:'wAddRec', 
					title:'Editar Unidad de Medida', 
					height:150, 
					width:630, 
					content:html,
					modal:true,
					posx: 120,
					posy: 70,
					onWindowClose: 
					function(){
						loadGridRows();
					}
				}
				);				
			}
			);		
	} else {
		alert('Debe seleccionar un registro.');
	}
}

function activarDesactivar(id_option)
{
	var id = oGrid.getSelectedId();
	if(confirm("\xBFConfirma que desea modificar el estatus de este registro?")){
		if (id != null) {
			$.post(
				oSubmenu.getUserData(id_option, 'action'),
				{
					id : id
				},
				function (response) {
					successfulOperation( response.msg );// simple Alerts!
					loadGridRows();
				},
				'json'
				)
		} else {
			alert('Debe seleccionar un registro.');
		}
	}
}