<?php

/**
 * Este archivo carga el base del html, y establece las variables a utilizar del mismo.
 * 
 */
require_once FS_CLASSES . 'Estados.php';
require_once FS_CLASSES . 'Municipios.php';
require_once FS_CLASSES . 'RegimenFiscalDAO.php';
require_once FS_CLASSES . 'PlantillasDAO.php';
require_once FS_CLASSES . 'ConfiguracionCuentaDAO.php';
require_once FS_CLASSES . 'UsuariosDAO.php';

$estados = new Estados();
$municipios = new Municipios();
$RegF = new RegimenFiscalDAO();
$configCuenta = new ConfiguracionCuentaDAO();
$objU = new UsuariosDAO();

$config = array_shift($configCuenta->cargaConfiguracionCuenta($_SESSION['user']->id_usuario));
$rowsRF = $RegF->listarRegimenFiscal();
// Se carga el archivo html
$oTpl->load(FS_CONFIGURACION_CONFIG_CUENTA . 'ventana.html');
$reg_fiscal_options = listForCombo($rowsRF, 'id_regimen_fiscal', 'descripcion', $config['id_regimen_fiscal']);


$oTpl->setVar(
		array(
			'FRAMEWORKURL' => WS_FRAMEWORK . 'js/',
			'BASE_URL' => WS_CONFIGURACION_CONFIG_CUENTA,
			'CONFIRM_URL' => encodeQueryString(array('do' => FS_CONFIGURACION_CONFIG_CUENTA . 'loadConfirm')),
			'BASE_URL' => WS_CONFIGURACION_CONFIG_CUENTA,
			'ID_USUARIO' => $_SESSION['user']->id_usuario,
			'ID_CONFIGURACION_CUENTA' => (!isset($config['id_configuracion_cuenta'])?0:$config['id_configuracion_cuenta']),
			'NOMBRE' => $config['nombre'],
			'RFC' => $config['rfc'],
			'E_MAIL' => $config['e_mail'],
			'TASA' => $config['tasa'],
			'CALLE' => $config['calle'],
			'NUM_EXT' => $config['num_ext'],
			'NUM_INT' => $config['num_int'],
			'COLONIA' => $config['colonia'],
			'CODIGO_POSTAL' => $config['codigo_postal'],
			'TELEFONOS' => $config['telefonos'],
			'REG_FISCAL_OPTIONS' => $reg_fiscal_options,
			'ESTADO_OPTIONS' => $estados->buildCombo($config['id_estado']),
			'MUNICIPIO_OPTIONS' => $municipios->buildCombo($config['id_estado'], $config['id_municipio']),
			'URL_LISTA_MUNICIPIOS' => encodeQueryString(array('do' => FS_CONFIGURACION_CONFIG_CUENTA . 'functions/loadMunicipios')),
			'ACTION' => encodeQueryString(array('do' => FS_CONFIGURACION_CONFIG_CUENTA . 'saveRow')),
			'SAT' => encodeQueryString(array('do' => FS_CONFIGURACION_CONFIG_CUENTA . 'infoSat'))
		)
);

$oTpl->publish();
?>