/*
* Archivo para manejo general de funciones en el modulo.
*/

// Inicialización de variables a usar en el archivo
var oSubmenu, oGrid, oWin, baseURL;

// Inicialización de eventos a ejecutar
$(document).ready(
	function () {
		//-- URL base del modulo
		baseURL = $('#dataGrid').attr('base_url');

		regsPage();
	}
);

// Inicializacion del menu y submenu
function regsPage(){
		//-- Inicialización de Submenu
		oSubmenu = new dhtmlXMenuObject("submenu_placeholder", 'dhx_submenu');
		oSubmenu.attachEvent("onClick", submenuClick);
		oSubmenu.loadXML($('#submenu_placeholder').attr('action'));
		
		//-- Inicialización de Grid
		oGrid = new dhtmlXGridObject('dataGrid');
		oGrid.setHeader("Id,Tipo,Nombre del Perfil,Permisos");
		oGrid.attachHeader("#text_filter,#select_filter,#text_filter");
		oGrid.setInitWidths("80,100,200,*");
		oGrid.setColAlign("center,left,left,left");
		oGrid.setSkin("dhx_blue");
		oGrid.setColTypes('ro,ro,ro,ro');
		oGrid.init();

		loadGridRows();
	}

// Funcion que ejecuta la accion para listar los registros.
function loadGridRows()
{
	$.post(
		$('#dataGrid').attr('url'),
		{},
		function (response) {
			oGrid.clearAll();
			oGrid.parse(response.data, 'json');
		},
		'json'
	);
}

// Función que carga las acciones correspondientes a la acción seleccionada del submenu
function submenuClick(id_option)
{
	action = oSubmenu.getUserData(id_option, 'script');
	
	if (action != null && action != '') {
		eval(action);
	} else {
		alert('No action specified for ' + id_option);
	}
}

// Función que ejecuta la acción de agregar un registro.
function addRow(id_option)
{
	$.post(
		oSubmenu.getUserData(id_option, 'action'),
		{},
		function (html) {
			oWin = $.newWindow(
				{id:'wAddRec', title:'Agregar Perfil', height:550, width:910, content:html,modal:true}
			);			
			loadJSFile(baseURL + 'agregar/agregar.js');
			$(".window-closeButton").hide();
		}
	)
}

// Función que ejecuta la acción de editar un registro.
function editRow(id_option)
{
	var id = oGrid.getSelectedId();

	if (id != null) {
		$.post(
			oSubmenu.getUserData(id_option, 'action'),
			{'id' : id},
			function (html) {
				oWin = $.newWindow(
					{id:'wEditRec', title:'Editar Perfil', height:550, width:910, content:html,modal:true}
				);	
				loadJSFile(baseURL + 'editar/editar.js');
				$(".window-closeButton").hide();
			}
		)
	} else {
		alert('Debe seleccionar un registro.');
	}
}

// Función que ejecuta la acción de consultar un registro.
function consultarRegistro(id_option)
{
	var id = oGrid.getSelectedId();

	if (id != null) {
		$.post(
			oSubmenu.getUserData(id_option, 'action'),
			{'id' : id},
			function (html) {
				oWin = $.newWindow({id:'wConsultarPerfil', title:'Consultar Perfil', width:910, height:550, content:html, modal:true});
				loadJSFile(baseURL + 'consultar/consultar.js');
				$(".window-closeButton").hide();
			}
		)
	} else {
		alert('Debe seleccionar un registro.');
	}
}

// Función que ejecuta la acción de activar/desactivar un registro.
function activarDesactivar(id_option)
{
	if(confirm("\xBFConfirma que desea modificar el estatus de este registro?")){
		var id = oGrid.getSelectedId();

		if (id != null) {
			$.post(
				oSubmenu.getUserData(id_option, 'action'),
				{"id" : id},
				function (response) {
					$.ajaxSetup({async:false});
						loadGridRows();
	//					successfulOperation( response.msg ); jquery UI dialogs!
						successfulOperation( response.msg );// simple Alerts!
					$.ajaxSetup({async:true});
				},
				'json'
			)
		} else {
			alert('Debe seleccionar un registro.');
		}
	}
}
