/*
 * Archivo para manejo general de funciones en el modulo.
 */

// Inicialización de variables a usar en el archivo
var oSubmenu, oGrid, oWin, baseURL;

// Inicialización de eventos a ejecutar
$(document).ready(
	function () {
		//-- URL base del modulo
		baseURL = $('#dataGrid').attr('base_url');

		//-- Inicialización de Submenu
		oSubmenu = new dhtmlXMenuObject("submenu_placeholder", 'dhx_submenu');
		oSubmenu.attachEvent("onClick", submenuClick);
		oSubmenu.loadXML($('#submenu_placeholder').attr('action'));

		//-- Inicialización de Grid
		oGrid = new dhtmlXGridObject('dataGrid');
		oGrid.setHeader("Id,Usuario,Nombre,Correo Electr&oacute;nico,\u00daltimo Acceso");
		oGrid.setInitWidths("80,130,370,200,200");
		oGrid.setColAlign("center,left,left,left,center");
		oGrid.setSkin("dhx_blue");
		oGrid.setColTypes('ro,ro,ro,ro,ro');
//		var custom_filter = 
//		'<input type=\"text\" 
//			id=\"filter_fec_desde_1\" maxlength=\"10\" class=\"custom_date_filter\" />'
//			+ ' a <input type=\"text\" 
//					id=\"filter_fec_hasta_1\" maxlength=\"10\" class=\"custom_date_filter\" />';
//		oGrid.attachHeader("#text_filter,#text_filter,#text_filter,#text_filter," + custom_filter);
		oGrid.attachHeader("#text_filter,#text_filter,#text_filter,#text_filter,#text_filter");
		oGrid.init();

		$.ajaxSetup({async:false});
		loadGridRows();
//		beginDateFilter();
		$.ajaxSetup({async:true});
	}
);

// Inicializa el evento para las campos date.
function beginDateFilter(){
	
		// -- Filtrado por fechas
		$('.custom_date_filter').change(
			function () {
				//-- Obtiene el numero de columna del elemento capturado
				var nCol = $(this).parent().parent().prevAll().length;
				var oInicio = $(this).parent().find('input:eq(0)');
				var oFin = $(this).parent().find('input:eq(1)');
				
				var inicio = oInicio.val().trim();
				oInicio.val(inicio);
				var fin = oFin.val().trim();
				oFin.val(fin);

				if (inicio.match(/^(\d{2}\/\d{2}\/\d{4})?$/) 
						&& inicio.match(/^(\d{2}\/\d{2}\/\d{4})?$/)) {
					if (fin == '') {
						fin = inicio;
					}

					inicio = (inicio == '' ? 0 : 
							parseInt(inicio.replace(/(\d{2}).(\d{2}).(\d{4})/, '$3$2$1')));
					fin = (fin == '' ? 0 : 
							parseInt(fin.replace(/(\d{2}).(\d{2}).(\d{4})/, '$3$2$1')));

					if (fin < inicio) {
						alert('Fecha final no puede ser menor que la fecha inicial.');
					} else {
						//-- comparamos valores de la columna 
						//nCol contra rango de fechas (true = mostrar, false = ocultar]
						oGrid.filterBy(nCol, 
							function (data) {
								var _fecha = 
										parseInt(data.toString().replace(/(\d{2}).(\d{2}).(\d{4})/,
													'$3$2$1'));
								return (inicio == 0 || _fecha >= inicio && _fecha <= fin);
							}
						);
					}
				} else {
					alert('formato incorrecto utilice dd/mm/aaaa.')
				}
			}
		);
}

// Funcion que ejecuta la accion para listar los registros.
function loadGridRows()
{
	$.post(
		$('#dataGrid').attr('url'),
		{},
		function (response) {
			oGrid.clearAll();
			oGrid.parse(response.data, 'json');
		},
		'json'
	);
}

// Función que carga las acciones correspondientes a la acción seleccionada del submenu
function submenuClick(id_option)
{
	var action = oSubmenu.getUserData(id_option, 'script');
	
	if (action != null && action != '') {
		eval(action);
	} else {
		alert('No action specified for ' + id_option);
	}
}

// Función que ejecuta la acción de agregar un registro.
function addRow(id_option)
{
	$.post(
		oSubmenu.getUserData(id_option, 'action'),
		{},
		function (html) {
//			oWin = addDHXWindow('wAddRec', 230, 50, 600, 450, 'Agregar Usuario', html);
			oWin = $.newWindow({id:'wAddUsuario', title:'Agregar Administrador', width:625, height:450, posx:230, posy:50, content:html, modal:true});
			loadJSFile(baseURL + 'agregar/agregar.js');
			$(".window-closeButton").hide();
		}
	)
}

// Función que ejecuta la acción de editar un registro.
function editRow(id_option)
{
	var id = oGrid.getSelectedId();
	
	if (id != null) {
		$.post(
			oSubmenu.getUserData(id_option, 'action'),
			{'id' : id},
			function (html) {
				oWin = $.newWindow(
					{
						id:'wEditUsuario', 
						title:'Modificar Administrador', 
						width:625, 
						height:450,
						posx:230, 
						posy:50, 
						content:html, 
						modal:true
					}
				);
				loadJSFile(baseURL + 'editar/editar.js');
				$(".window-closeButton").hide();
			}
		)
	} else {
		alert('Debe seleccionar un registro.');
	}
}

// Función que ejecuta la acción de consultar un registro.
function consultarRegistro(id_option)
{
	var id = oGrid.getSelectedId();

	if (id != null) {
		$.post(
			oSubmenu.getUserData(id_option, 'action'),
			{'id' : id},
			function (html) {
				oWin = $.newWindow(
						{
							id:'wConsultarUsuario', 
							title:'Consulta de Administrador', 
							width:625, 
							height:450, 
							posx:230, 
							posy:50, 
							content:html, 
							modal:true});
				loadJSFile(baseURL + 'consultar/consultar.js');
				$(".window-closeButton").hide();
			}
		)
	} else {
		alert('Debe seleccionar un registro.');
	}
}

// Función que ejecuta la acción de activar/desactivar un registro.
function activarDesactivar(id_option)
{
	if(confirm("\xBFConfirma que desea modificar el estatus de este registro?")){
		var id = oGrid.getSelectedId();

		if (id != null) {
			$.post(
				oSubmenu.getUserData(id_option, 'action'),
				{"id" : id},
				function (response) {
					if(response.send < 1){
						successfulOperation("Error al notificar via e_mail");
					} else {
						loadGridRows();
						successfulOperation(response.msg);
					}
				},
				'json'
			)
		} else {
			alert('Debe seleccionar un registro.');
		}
	}
}