/*
 * Archivo que carga funciones y eventos del módulo.
 */

// Inicialización de eventos a ejecutar
$(document).ready(
	function () {
		initCssButtons();
		initInactiveControls();

		//-- Inicialización de Grid
		oGridPaq = new dhtmlXGridObject('dataGridPaq');
		oGridPaq.setHeader("Paquete,Fecha Compra,Cantidad,Utilizados,Vencimiento");
		oGridPaq.setInitWidths("*,90,80,80,90");
		oGridPaq.setColAlign("left,center,center,center,center");
		oGridPaq.setSkin("dhx_blue");
		oGridPaq.setColTypes('ro,ro,ro,ro,ro');
		oGridPaq.attachEvent('onRowSelect', gridPaqOptions);
		oGridPaq.init();

		$.ajaxSetup({async:false});
		loadGridPaqRows();
		
		$.ajaxSetup({async:true});
		
		$('#btnAddPaq').click(agregarPaquete);
		$('#btnDelPaq').click(eliminarPaquete);
		
		$('#btnClosePaq').click(
			function() {
				oWin.close();
			}
		);			
	}
);


function loadGridPaqRows()
{
	$.post(
		$('#dataGridPaq').attr('url'),
		{ 'id_usuario' : $('#id_usuario').val() },
		function (response) {
			oGridPaq.clearAll();
			oGridPaq.parse(response.data, 'json');
			gridPaqOptions();
		},
		'json'
	);
}


function gridPaqOptions()
{
	var id = oGridPaq.getSelectedId();
	
	$('#btnDelPaq').button('option', 'disabled', id == null)
}


function agregarPaquete()
{
	$.post(
		$('#btnAddPaq').attr('url'),
		{
			'id_usuario' : $('#id_usuario').val(),
			'nombre_usuario' : $('#nombre_usuario').val()
		},
		function (html) {
				oWinAddPaq = $.newWindow(
					{
						id: 'wAddPaqUsuario', 
						title: 'Agregar Paquete a Cuenta de Usuario', 
						width: 550, 
						height: 95,
						posx: 200, 
						posy: 190, 
						content: html, 
						modal: true
					}
				);
				
				$(".window-closeButton").hide();
				
				initCssButtons();
				initInactiveControls();
				
				$('#btnAddPaqUser').click(agregarPaqueteCuenta);
				
				$('#btnClosePaqUser').click(
					function () {
						oWinAddPaq.close();
					}
				);
		},
		'html'
	);
}


function eliminarPaquete()
{
	var id = oGridPaq.getSelectedId();
	
	if (id != null) {
		if (confirm('Confirme para eliminar el paquete de la cuenta')) {
			$.post(
				$('#btnDelPaq').attr('url'),
				{ 'id_usuario_paquete' : id },
				function () {
					loadGridPaqRows();
				},
				'json'
			);
		}
	} else {
		alert('Debe seleccionar un registro.');
	}
}


function agregarPaqueteCuenta()
{
	$.post(
		$('#btnAddPaqUser').attr('url'),
		{
			'id_usuario' : $('#id_usuario').val(),
			'id_paquete' : $('#id_paquete').val()
		},
		function () {
			loadGridPaqRows();
			$('#btnClosePaqUser').click();
		},
		'json'
	);
}