/**
 *	Archivo para la funcionalidad Agregar sucursal
 **/

/**
 *Inicializacion de la plantilla agregar sucursal
 **/
var cant = 0;
$(document).ready(function() {
	initCssButtons();
	initInactiveControls();
	setFormats();
	comboDynamic();
	$('#nombre').focus();
	$('#btnClose').click(
			function() {
				if (confirm("Confirme para salir")) {
					loadGridRows();
					oWinFac.close();
				}
			}
	);
	createGrid();
	$("#add_note").click(agregarNota);
	$('#btnSaveFactura').click(saveInfo);
	$('#cantidad,.money').val(0).blur();


	doOnLoad();

});
/**
 * Funcion que guarda la informacion capturada por el usuario
 **/
function saveInfo() {
	if ($('#sReceptor').val() == '0') {
		alert('Se debe elegir un cliente.');
		return false;
	}
	if ($('#sForma_pago').val() == '0') {
		alert('Se debe elegir una Forma de Pago.');
		return false;
	}
	if ($('#sMetodo_pago').val() == '0') {
		alert('Se debe elegir un Metodo de Pago.');
		return false;
	}

	//-- Valida IVA vs Retencion IVA
	var iva = parseFloat(unformatMoney($('#iva_total').val()));
	var retencion_iva = parseFloat(unformatMoney($('#retencion_iva_total').val()));

	if (retencion_iva > iva) {
		$('#iva_retenido').focus();
		alert('Retención de IVA no puede ser mayor a IVA de la factura.');
		return;
	}
	
	
	var ieps = parseFloat(unformatMoney($('#ieps_total').val()));
	var retencion_ieps = parseFloat(unformatMoney($('#retencion_ieps_total').val()));
	if (retencion_ieps > ieps) {
		alert('Retención de IEPS no puede ser mayor al IEPS de la factura.');
		return;
	}

	var array_str = "";
	$("#nDigitos_tarjeta").val($("#digitos_tarjeta").val());

	var num = oGridC.getRowsNum();
	//Se obtienen los valores de la tabla de conceptos
	oGridC.forEachRow(function(id) {
		array_str += oGridC.cells(id, 0).getValue() + "[,] "
				+ oGridC.cells(id, 1).getValue() + "[,] "
				+ oGridC.cells(id, 2).getValue() + "[,] "
				+ unformatMoney(oGridC.cells(id, 3).getValue()) + "[,] "
				+ oGridC.cells(id, 4).getValue() + "[,] "
				+ oGridC.cells(id, 5).getValue() + "[,] "
				+ unformatMoney(oGridC.cells(id, 6).getValue()) + "[,] "
				+ unformatMoney(oGridC.cells(id, 7).getValue()) + "[,] "
				+ unformatMoney(oGridC.cells(id, 8).getValue()) + "[,] "
				+ unformatMoney(oGridC.cells(id, 9).getValue()) + "[,] "
				+ unformatMoney(oGridC.cells(id, 10).getValue()) + "[,] "
				+ oGridC.cells(id, 11).getValue() + "[,] "
				+ oGridC.cells(id, 13).getValue() + "[-] ";
	});
	
	$("#lista_conceptos").val(array_str);
	$.post(
			$('#btnSaveFactura').attr('url'),
			$('#frmAddComprobante').serializeArray(),
			function(response) {
				if (response.ok) {
					successfulOperation(response.msg);
					loadGridRows();
					oWinFac.close(true);
				} else {
					$('.error').removeClass('error');
					$(response.error.ids).prev().filter('label').addClass('error');
					alert(response.error.msg);
				}
			},
			'json'
			);
}

$('#sMetodo_pago').change(function() {
	$.post(
			//Se especifica que el elemento asignado "(this)" ejecute lo que esta en el action
			$(this).attr('action'),
			//Se envia el(los) parametro(s)
					{id_metodo: $(this).val()},
			function(response) {
				if (response.digitos_tarjeta == 1) {
					$('#digitos_tarjeta').removeAttr('disabled');
				} else {
					$('#digitos_tarjeta').attr('disabled', 'disabled').val('');
				}
			},
					'json');
		});

function doOnLoad() {
	window.dhx_globalImgPath = "css/img/";
	var combo_productos = $("#descripcion").attr("url");
	var combo = new dhtmlXCombo("descripcion", "alfa", 200);
	combo.enableFilteringMode(true, combo_productos, true, false);
	combo.attachEvent("onChange", onSelectionChangeFunc);
}

function onSelectionChangeFunc() {
	
	
	var id = this.getSelectedValue();
	if (id != null) {
		$("#sDescripcion").val(this.getSelectedText());
		$.post($('.comboDescripcion').attr('url_inf'),
				{id_producto_servicio: id},
		function(response) {
			var precio_unitario = response.precio_unitario;
			var iva = response.iva;
			var tasa_iva = response.tasa_iva;
			var tasa_ieps = response.tasa_ieps;
			var ieps = response.ieps;
			var porc_ret_iva = response.retencion_iva;
			var porc_ret_isr = response.retencion_isr;
			var ret_iva = response.ret_iva;
			var ret_isr = response.ret_isr;
			var ret_ieps = response.retencion_ieps;
			var porc_ret_ieps = response.porc_ret_ieps;
			
			$("#precio_unitario").val(formatMoney(precio_unitario));
			$("#tipo_unidad").val(response.id_unidad_medida);
			$("#tasa_iva").val(tasa_iva);
			$("#tasa_ieps").val(tasa_ieps);
			$("#porc_ret_iva").val(porc_ret_iva);
			$("#porc_ret_isr").val(porc_ret_isr);
			$("#iva").val(roundNumber(iva, 6).toFixed(6));
			$("#ret_iva").val(roundNumber(ret_iva, 6));
			$("#ret_isr").val(roundNumber(ret_isr, 6));
			$("#porc_ret_ieps").val(roundNumber(porc_ret_ieps, 6).toFixed(6));
			$("#ret_ieps").val(roundNumber(ret_ieps, 6).toFixed(6));
			$("#ieps").val(roundNumber(ieps, 6));
			$("#desglozar_iva").val(response.impuestos);
			$('#cantidad').val(1).focus();
			
		}, 'json');
		this.setComboValue('');
	}
}


$('#precio_unitario').change(function() {
		CalculaValores();
});

$('#tasa_iva').change(function() {
		CalculaValores();
});

$('#tasa_ieps').change(function() {
		CalculaValores();
});

$('#porc_ret_iva').change(function() {
		CalculaValores();
});
$('#ret_iva').change(function() {
		CalculaValores("retencion_iva");
});

$('#porc_ret_isr').change(function() {
		CalculaValores();
});
$('#ret_isr').change(function() {
		CalculaValores("retencion_isr");
});

$('#tipo_ieps').change(function() {
		CalculaValores();
});

$('#porc_ret_ieps').change(function() {
		CalculaValores();
});

$('#ret_ieps').change(function() {
		CalculaValores("retencion_ieps");
});

$('#iva_exento').change(function() {
	if($("#cantidad").val() > 0){
		CalculaValores();
	}
});

function createGrid() {
	//-- Inicialización de Grid
	oGridC = new dhtmlXGridObject('dataGridConceptos');
	oGridC.setSkin("dhx_blue");
	oGridC.setHeader("Cantidad, Descripcion, Unidad, P. Unitario, Tasa IVA, IVA, IEPS, Ret. IVA, Ret. ISR, Ret. IEPS, Importe, tasa_ieps, id_unidad,iva_exento");
	oGridC.setInitWidths("65,215,65,80,80,0,80,80,80,80,90,0,0,0");
	oGridC.setColAlign("center,left,left,left,left,left,left,left,left,right,right,left,left,left");
	oGridC.setColTypes('ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro');
	oGridC.setColSorting("int,str,str,int,str,int,int,int,int,int,int,int,int,int");
	oGridC.enableResizing("false,false,false,false,false,false,false,false,false,false,false,false,false,false");
	oGridC.enableStableSorting(false);
	oGridC.enableEditEvents(false, false, false);
	oGridC.init();

	//Evento al agregar una nueva fila
	oGridC.attachEvent("onRowAdded", function(rId) {
		onEditRow(rId);
	});

	oGridC.attachEvent("onRowSelect", function(id, ind) {
		var cantidad = oGridC.cells(id, 0).getValue();
		var precio_unitario = parseFloat(unformatMoney(oGridC.cells(id, 3).getValue()));
		var iva = (parseFloat(unformatMoney(oGridC.cells(id, 5).getValue())).toFixed(6)) / cantidad;
		var ieps = (parseFloat(unformatMoney(oGridC.cells(id, 6).getValue())));
		var ret_iva = (parseFloat(unformatMoney(oGridC.cells(id, 7).getValue())));
		var ret_isr = (parseFloat(unformatMoney(oGridC.cells(id, 8).getValue())));
		var ret_ieps = (parseFloat(unformatMoney(oGridC.cells(id, 9).getValue())));
		var porc_ret_iva = roundNumber((ret_iva * 100) / (precio_unitario + ieps), 6);
		var porc_ret_isr = roundNumber((ret_isr * 100) / (precio_unitario + ieps), 6);
		var porc_ret_ieps = roundNumber((ret_ieps * 100) / (precio_unitario + ieps), 6);
		var tasa_ieps = parseFloat(oGridC.cells(id, 11).getValue());
		var iva_exento = parseFloat(oGridC.cells(id, 13).getValue());
		if (iva_exento == 1) {
			$("#iva_exento").prop("checked", true);
		}else{
			$("#iva_exento").prop("checked", false);
		}
		
		$("#cantidad").val(oGridC.cells(id, 0).getValue());
		$("#precio_unitario").val(formatMoney(precio_unitario));
		$("#sDescripcion").val(oGridC.cells(id, 1).getValue());
		$("#tipo_unidad").val(oGridC.cells(id, 12).getValue());
		$("#tasa_iva").val(parseFloat(unformatMoney(oGridC.cells(id, 4).getValue())).toFixed(6));
		$("#iva").val(iva.toFixed(6));
		$("#ieps").val(ieps);
		$("#tasa_ieps").val(tasa_ieps.toFixed(6));
		$("#ret_iva").val(ret_iva);
		$("#porc_ret_iva").val(porc_ret_iva.toFixed(6));
		$("#ret_isr").val(ret_isr);
		$("#porc_ret_isr").val(porc_ret_isr.toFixed(6));
		$("#ret_ieps").val(ret_ieps);
		$("#porc_ret_ieps").val(porc_ret_ieps.toFixed(6));
		$("#tipo_ieps").val(1);

	});
}

$('.add').click(function() {
	var cantidad = $('#cantidad').val();
	var precio_unitario = (parseFloat(unformatMoney($('#precio_unitario').val())));
	var tipo_unidad = $('#tipo_unidad option:selected').html();
	var id_unidad = $('#tipo_unidad').val();
	var descripcion = $('#sDescripcion').val();
	var tasa_iva = roundNumber($("#tasa_iva").val(), 2) + "%";
	var iva = parseFloat($("#iva").val());
	var ieps = parseFloat($("#ieps").val());
	var tasa_ieps = parseFloat($("#tasa_ieps").val());
	var retencion_iva = parseFloat($("#ret_iva").val());
	var retencion_isr = parseFloat($("#ret_isr").val());
	var retencion_ieps = parseFloat($("#ret_ieps").val());
	var iva_exento = $("#iva_exento").val();
	if ($("#iva_exento").is(':checked')) {
		iva_exento = 1;
	}else{
		iva_exento = 0;
	}
	
	var subtotal = 0;

	if ($('#fTasa_iva').val() == '') {
		alert("Se debe ingresar un valor para el IVA.");
		return false;
	}
	if (cantidad == 0) {
		alert("La cantidad debe ser mayor a cero.");
		return false;
	}

	if (precio_unitario == 0) {
		alert("El precio debe ser mayor a cero.");
		return false;
	}
	var new_id = oGridC.getRowsNum() + 1;

	subtotal = roundNumber((precio_unitario) * cantidad, 2);

	precio_unitario = formatMoney(precio_unitario);

	ieps = formatMoney(roundNumber(ieps, 6));

	retencion_iva = formatMoney(roundNumber(retencion_iva, 6));

	retencion_isr = formatMoney(roundNumber(retencion_isr, 6));
	
	retencion_ieps = formatMoney(roundNumber(retencion_ieps, 6));

	subtotal = formatMoney(roundNumber(subtotal, 6));

	iva = iva * cantidad;
	
	oGridC.addRow(new_id,
			[cantidad,
				descripcion,
				tipo_unidad,
				precio_unitario,
				tasa_iva,
				roundNumber(iva, 2),
				ieps,
				retencion_iva,
				retencion_isr,
				retencion_ieps,
				subtotal,
				tasa_ieps,
				id_unidad,
				iva_exento
			]
			, 0);

	$('#cantidad,#precio_unitario').val(0).blur();
	$('#tipo_unidad').val('');
	$('#sDescripcion').val('');
	$('#cantidad').val('');
	$('#tasa_iva').val('');
	$('#tasa_ieps').val('');
	$('#porc_ret_iva').val('');
	$('#porc_ret_isr').val('');
	$('#porc_ret_ieps').val('');
	$('#iva').val('');
	$('#ieps').val('');
	$('#ret_iva').val('');
	$('#ret_isr').val('');
	$('#ret_ieps').val('');
	$('#precio_unitario').val('');
	$('#descripcion').val('0');
	$("#iva_exento").prop('checked', false);

});


$('.del').click(function() {
	var rId = oGridC.getSelectedRowId();
	if (rId !== undefined) {
		oGridC.deleteRow(rId);
		onEditRow(rId);

		$('#cantidad,#precio_unitario').val(0).blur();
		$('#tipo_unidad').val('');
		$('#sDescripcion').val('');
		$('#descripcion').val(0).focus();
	} else {
		alert("Selecciona la fila a eliminar.");
	}
});

$('.mod').click(function() {
	var rId = oGridC.getSelectedRowId();
	var cantidad = $('#cantidad').val();
	var precio_unitario = (parseFloat(unformatMoney($('#precio_unitario').val())));
	var tipo_unidad = $('#tipo_unidad option:selected').html();
	var id_unidad = $('#tipo_unidad').val();
	var descripcion = $('#sDescripcion').val();
	var tasa_iva = roundNumber($("#tasa_iva").val(), 2) + "%";
	var tasa_ieps = roundNumber($("#tasa_ieps").val(), 2);
	var iva = parseFloat($("#iva").val());
	var ieps = parseFloat($("#ieps").val());
	var retencion_iva = parseFloat($("#ret_iva").val());
	var retencion_isr = parseFloat($("#ret_isr").val());
	var retencion_ieps = parseFloat($("#ret_ieps").val());
	var iva_exento = 0;
	if ($("#iva_exento").is(':checked')) {
		iva_exento = 1;
	}
	
	var subtotal = 0;

	if (cantidad == 0) {
		alert("La cantidad debe ser mayor a cero.");
		return false;
	}

	if (precio_unitario == 0) {
		alert("El precio debe ser mayor a cero.");
		return false;
	}

	subtotal = roundNumber(precio_unitario  * cantidad, 2);

	precio_unitario = formatMoney(precio_unitario);

	ieps = formatMoney(ieps);

	retencion_iva = formatMoney(retencion_iva);

	retencion_isr = formatMoney(retencion_isr);
	
	retencion_ieps = formatMoney(retencion_ieps);

	subtotal = formatMoney(subtotal);

	iva = iva * cantidad;

	var rInd = (oGridC.getRowIndex(rId));
	oGridC.deleteRow(rId);

	oGridC.addRow(rId,
			[cantidad,
				descripcion,
				tipo_unidad,
				precio_unitario,
				tasa_iva,
				roundNumber(iva, 2),
				ieps,
				retencion_iva,
				retencion_isr,
				retencion_ieps,
				subtotal,
				tasa_ieps,
				id_unidad,
				iva_exento
			]
			, rInd);
	onEditRow();

	$('#cantidad,#precio_unitario').val(0).blur();
	$('#tipo_unidad').val('');
	$('#sDescripcion').val('');
	$('#cantidad').val('');
	$('#tasa_iva').val('');
	$('#tasa_ieps').val('');
	$('#porc_ret_iva').val('');
	$('#porc_ret_isr').val('');
	$('#porc_ret_ieps').val('');
	$('#iva').val('');
	$('#ieps').val('');
	$('#ret_iva').val('');
	$('#ret_isr').val('');
	$('#ret_ieps').val('');
	$('#precio_unitario').val('');

	$('#descripcion').val(0).focus();

});

function onEditRow() {
	var subtotal = 0;
	var iva_total = 0;
	var retencion_iva = 0;
	var retencion_isr = 0;
	var retencion_ieps = 0;
	var ieps_total = 0;
	var total = 0;
	var cantidad = 0;

	var num = oGridC.getRowsNum();
	for (var i = 1; i <= num; i++) {
		cantidad = oGridC.cells(i, 0).getValue();
		subtotal += parseFloat(unformatMoney(oGridC.cells(i, 10).getValue()));
		retencion_iva += parseFloat(unformatMoney(oGridC.cells(i, 7).getValue()));
		retencion_isr += parseFloat(unformatMoney(oGridC.cells(i, 8).getValue()));
		retencion_ieps += parseFloat(unformatMoney(oGridC.cells(i, 9).getValue()));
		ieps_total += (parseFloat(unformatMoney(oGridC.cells(i, 6).getValue())))*cantidad;
		iva_total += parseFloat(unformatMoney(oGridC.cells(i, 5).getValue()));
	}

	total = formatMoney(roundNumber((subtotal + ieps_total + iva_total) - retencion_iva - retencion_isr - retencion_ieps, 2));
	total = total.substring(0, total.length - 4);

	retencion_iva = formatMoney(roundNumber(retencion_iva, 2));
	retencion_iva = retencion_iva.substring(0, retencion_iva.length - 4);

	retencion_isr = formatMoney(roundNumber(retencion_isr, 2));
	retencion_isr = retencion_isr.substring(0, retencion_isr.length - 4);

	retencion_ieps = formatMoney(roundNumber(retencion_ieps, 2));
	retencion_ieps = retencion_ieps.substring(0, retencion_ieps.length - 4);

	ieps_total = formatMoney(roundNumber(ieps_total, 3));
	ieps_total = ieps_total.substring(0, ieps_total.length - 4);

	iva_total = formatMoney(roundNumber(iva_total, 2));
	iva_total = iva_total.substring(0, iva_total.length - 4);

	subtotal = formatMoney(roundNumber(subtotal, 2));
	subtotal = subtotal.substring(0, subtotal.length - 4);


	$("#retencion_iva_total").val(retencion_iva);
	$("#retencion_isr_total").val(retencion_isr);
	$("#retencion_ieps_total").val(retencion_ieps);
	$("#ieps_total").val(ieps_total);
	$("#iva_total").val(iva_total);
	$("#subtotal").val(subtotal);
	$("#total").val(total);

	setFormats();
}

function CalculaValores(opc) {
	var precio_unitario = parseFloat(unformatMoney($("#precio_unitario").val()));
	var tasa_ieps = parseFloat($("#tasa_ieps").val());
	var ieps_cant = parseFloat($("#ieps").val());
	var ret_ieps = parseFloat($("#ret_ieps").val());
	var porc_ret_iva = parseFloat($("#porc_ret_iva").val());
	var retencion_iva = parseFloat($("#ret_iva").val());
	var porc_ret_isr = parseFloat($("#porc_ret_isr").val());
	var porc_ret_ieps = parseFloat($("#porc_ret_ieps").val());
	var retencion_isr = parseFloat($("#ret_isr").val());
	var tasa_iva = parseFloat($("#tasa_iva").val());
	var tipo_ieps = parseFloat($("#tipo_ieps").val());
	
	var iva = 0;
	if(tasa_iva > 0){
		$("#tasa_iva_back").val(tasa_iva);
	}else if($("#tasa_iva_back").val() > 0){
		tasa_iva = parseFloat($("#tasa_iva_back").val());
	}else{
		tasa_iva = 0;
	}
	
	//IEPS
	if (tipo_ieps == '1') {
		var aux = precio_unitario;
		precio_unitario = precio_unitario * ((tasa_ieps / 100) + 1);
		ieps_cant = precio_unitario - aux;		
	} else {
		var aux = precio_unitario;
		precio_unitario = precio_unitario + tasa_ieps;
		ieps_cant = tasa_ieps;
	}

	//IVA
	iva = roundNumber((precio_unitario * ((tasa_iva / 100) + 1)), 6) - precio_unitario;

	if (opc == "retencion_iva") {
		//PORCENTAJE DE RETENCION DE IVA
		porc_ret_iva = (retencion_iva * 100) / precio_unitario;
	} else {
		//RETENCION IVA
		retencion_iva = (precio_unitario * ((porc_ret_iva / 100) + 1)) - precio_unitario;
	}

	if (opc == "retencion_isr") {
		//PORCENTAJE DE RETENCION DE ISR
		porc_ret_isr = (retencion_isr * 100) / precio_unitario;
	} else {
		//RETENCION ISR
		retencion_isr = roundNumber((precio_unitario * ((porc_ret_isr / 100) + 1)), 6) - precio_unitario;
	}
	
	if (opc == "retencion_ieps") {
		//PORCENTAJE DE RETENCION DE ISR
		porc_ret_ieps = (ret_ieps * 100) / precio_unitario;
	} else {
		//RETENCION ISR
		ret_ieps = roundNumber((precio_unitario * ((porc_ret_ieps / 100) + 1)), 6) - precio_unitario;
	}
	
	if ($("#iva_exento").is(':checked')) {
		$("#iva").val(roundNumber(0, 6));
		$("#tasa_iva").val(roundNumber(0, 6));
	}else{
		$("#iva").val(roundNumber(iva, 6));
		$("#tasa_iva").val(roundNumber(tasa_iva, 6));
	}
	
	if(retencion_iva > 0){
		$("#ret_iva").val(retencion_iva.toFixed(6));
	}else{
		$("#ret_iva").val(0.000000);
	}
	
	if(porc_ret_iva > 0){
		$("#porc_ret_iva").val(porc_ret_iva.toFixed(6));
	}else{
		$("#porc_ret_iva").val(0.000000);
	}
	
	if(retencion_isr > 0){
		$("#ret_isr").val(roundNumber(retencion_isr, 6));
	}else{
		$("#ret_isr").val(0.000000);
	}
	
	if(porc_ret_isr > 0){
		$("#porc_ret_isr").val(porc_ret_isr.toFixed(6));
	}else{
		$("#porc_ret_isr").val(0.000000);
	}
	
	if(ieps_cant > 0){
		$("#ieps").val(roundNumber(ieps_cant, 6));
	}else{
		$("#ieps").val(0.0000000);
	}
	
	if(ret_ieps > 0){
		$("#ret_ieps").val(roundNumber(ret_ieps, 6));
	}else{
		$("#ret_ieps").val(0.0000000);
	}
	
	if(porc_ret_ieps > 0){
		$("#porc_ret_ieps").val(porc_ret_ieps.toFixed(6));
	}else{
		$("#porc_ret_ieps").val(0.0000000);
	}
	
	
}


function agregarNota(id_option) {
	$.post(
			$('#add_note').attr('_url'),
			{
			},
			function(html) {
				var viewportWidth = parseInt($('body').innerWidth());
				loadJSFile(baseURL + 'agregar/notas.js');
				oWinNote = $.newWindow(
						{
							id: 'conten_note',
							title: 'Agregar Nota a Comprobante',
							height: 150,
							width: 500,
							content: html,
							modal: true,
							posx: Math.max((viewportWidth - 500) / 2, 10),
							posy: 50
						}
				);
			}
	);
}
