/**
 *	Archivo para la funcionalidad Agregar sucursal
 **/

/**
 *Inicializacion de la plantilla agregar sucursal
 **/
var cant = 0;
$(document).ready(
		function() {
			initCssButtons();
			initInactiveControls();
			setFormats();
			comboDynamic();
			
			$('#nombre').focus();
			$('#btnClose').click(
					function() {
						if (confirm("Confirme para salir")) {
							loadGridRows();
							oWinFac.close();
						}
					}
			);
			createGrid();
			$('#btnSaveFactura').click(saveInfo);
			$('#cantidad,.money').val(0).blur();
		}
);
/**
 * Funcion que guarda la informacion capturada por el usuario
 **/
function saveInfo() {
	if ($('#sReceptor').val() == '0') {
		alert('Se debe elegir un cliente.');
		return false;
	}
//	if ($('#sEmisor').val() < '0') {
//		alert('Se debe elegir una Sucursal.');
//		return false;
//	}
	if ($('#sForma_pago').val() == '0') {
		alert('Se debe elegir una Forma de Pago.');
		return false;
	}
	if ($('#sMetodo_pago').val() == '0') {
		alert('Se debe elegir un Metodo de Pago.');
		return false;
	}

	//-- Valida IVA vs Retencion IVA
	var iva = parseFloat(unformatMoney($('#iva_total').val()));
	var retencion_iva = parseFloat(unformatMoney($('#iva_retenido').val()));
	
	if (retencion_iva > iva) {
		$('#iva_retenido').focus();
		alert('Retención de IVA no puede ser mayor a IVA de la factura.');
		return;
	}

	var array_str = "";
//	if ($("#digitos_tarjeta").val() == '') {
//		$("#nDigitos_tarjeta").val(0);
//	} else {
		$("#nDigitos_tarjeta").val($("#digitos_tarjeta").val());
//	}

	var num = oGridC.getRowsNum();
	var tasa_iva = $("#fTasa_iva").val();
	//Se obtienen los valores de la tabla de conceptos
	oGridC.forEachRow(function(id) {
			array_str += oGridC.cells(id, 0).getValue() + "[,] "
				+ oGridC.cells(id, 1).getValue() + "[,] "
				+ oGridC.cells(id, 2).getValue() + "[,] "
				+ unformatMoney(oGridC.cells(id, 3).getValue()) + "[,] "
		
				+ tasa_iva + "[,] "
				+ "0.0[,] "
				+ "0.0[,] "
				+ "0.0[,] "
				+ "0.0[,] "
				+ "0.0[,] "
				+ unformatMoney(oGridC.cells(id, 4).getValue()) + "[,] "
				+ "0.0[-] ";
	});
	
	$("#lista_conceptos").val(array_str);
	$.post(
			$('#btnSaveFactura').attr('url'),
			$('#frmAddComprobante').serializeArray(),
			function(response) {
				if (response.ok) {
					successfulOperation(response.msg);
					loadGridRows();
					oWinFac.close(true);
				} else {
					$('.error').removeClass('error');
					$(response.error.ids).prev().filter('label').addClass('error');
					alert(response.error.msg);
				}
			},
			'json'
			);
}


$('#sMetodo_pago').change(function() {
	$.post(
			//Se especifica que el elemento asignado "(this)" ejecute lo que esta en el action
			$(this).attr('action'),
			//Se envia el(los) parametro(s)
					{id_metodo: $(this).val()},
			function(response) {
				if (response.digitos_tarjeta == 1) {
					$('#digitos_tarjeta').removeAttr('disabled');
				} else {
					$('#digitos_tarjeta').attr('disabled', 'disabled').val('');
				}
			},
			'json');
		});

$('.comboSucursal').change(function() {
	$.post(
			//Se especifica que el elemento asignado "(this)" ejecute lo que esta en el action
			$(this).attr('action'),
			//Se envia el(los) parametro(s)
					{id_sucursal: $(this).val()},
			function(response) {
				$('#fTasa_iva').val(response.fTasa_Iva);
				onEditRow();
			},
			'json')
		});



$('.comboDescripcion').change(function() {
	var id = ($('.comboDescripcion').val());
	var selec = $(".comboDescripcion option:selected").html();
	$("#sDescripcion").val(selec.toUpperCase());
	
	$.post($('.comboDescripcion').attr('url'),
			{},
			function(response) {
				var cant = response.listProductoServicio.length;
				for (var i = 0; i < cant; i++) {
					if (id == response.listProductoServicio[i].id_producto_servicio) {
						$("#precio_unitario").val(response.listProductoServicio[i].precio_unitario).blur();
						$("#tipo_unidad").val(response.listProductoServicio[i].nombre_medida);
						$('#cantidad').val(1).focus();
					}
				}
			}, 'json');
});

$('#iva_total,#iva_retenido').change(
	function () {
		var subtotal = parseFloat(unformatMoney($('#subtotal').val()));
		var iva = parseFloat(unformatMoney($('#iva_total').val()));
		var retencion_iva = parseFloat(unformatMoney($('#iva_retenido').val()));
		var total = roundNumber(subtotal + iva - retencion_iva, 2);
		
		$('#total').val(total).blur();
	}
);

function createGrid() {

	//-- Inicialización de Grid
	oGridC = new dhtmlXGridObject('dataGridConceptos');
	oGridC.setSkin("dhx_blue");
	oGridC.setHeader("Cantidad, Descripcion, Unidad, P. Unitario, Importe");
	oGridC.setInitWidths("80, 300, 95, 100, 120");
	oGridC.setColAlign("center,left, left, right, right");
//	oGridC.setColTypes('ro,ro,ro,ed,price[=c0*c3]');
	oGridC.setColTypes('ro,ro,ro,ro,ro');
	oGridC.setColSorting("int,str,str,int,int");
	oGridC.enableResizing("false,false,false,false,false");
//	oGridC.enableMathEditing(false);
//	oGridC.setMathRound(2);
	oGridC.enableStableSorting(true);
	//oGridC.setNumberFormat("0,000.00",3);


	oGridC.enableEditEvents(false, false, false);
	oGridC.init();

	//Evento al agregar una nueva fila
	oGridC.attachEvent("onRowAdded", function(rId) {
		onEditRow(rId);
	});

	oGridC.attachEvent("onRowSelect", function(id, ind) {
		$("#cantidad").val(oGridC.cells(id, 0).getValue());
		$("#precio_unitario").val(oGridC.cells(id, 3).getValue());
		$("#sDescripcion").val(oGridC.cells(id, 1).getValue());
		$("#tipo_unidad").val(oGridC.cells(id, 2).getValue());
	});
	//Evento al eliminar una fila
//	oGridC.attachEvent("onAfterRowDeleted", function(rId) {
//		var subtotal = 0;
//		var iva_total = 0;
//		var total = 0;
//		var num = oGridC.getRowsNum();
//		for (var i = 0; i < num; i++) {
//			subtotal += cells(i,4).getValue();
//		}
//		alert(subtotal);
//	});
}

$('.add').click(function() {
	var cantidad = $('#cantidad').val();
	var precio_unitario = parseFloat(unformatMoney($('#precio_unitario').val()));
	var tipo_unidad = $('#tipo_unidad').val();
	var comboDescripcion = $('#descripcion').val();
	var descripcion = $('#sDescripcion').val();
	var subtotal = roundNumber(cantidad * precio_unitario, 2);

	if (cantidad != '' && precio_unitario != '' && tipo_unidad != '') {

		if ($('#fTasa_iva').val() == '') {
			alert("Se debe ingresar un valor para el IVA.");
			return false;
		} else
		if (cantidad == 0) {
			alert("La cantidad debe ser mayor a cero.");
			return false;
		} else
		if (precio_unitario == 0) {
			alert("El precio debe ser mayor a cero.");
			return false;
		}
		var new_id = oGridC.getRowsNum() + 1;


		oGridC.addRow(new_id, [cantidad, descripcion, tipo_unidad, formatMoney(precio_unitario), formatMoney(subtotal)], 0);

		$('#cantidad,#precio_unitario').val(0).blur();
		$('#tipo_unidad').val('');
		$('#sDescripcion').val('');
		$('#descripcion').val(0).focus();
	} else {
		alert("Se deben ingresar todos los campos.");
	}
});


$('.del').click(function() {
	var rId = oGridC.getSelectedRowId();
	if (rId !== undefined) {
		oGridC.deleteRow(rId);
		onEditRow(rId);

		$('#cantidad,#precio_unitario').val(0).blur();
		$('#tipo_unidad').val('');
		$('#sDescripcion').val('');
		$('#descripcion').val(0).focus();
	} else {
		alert("Selecciona la fila a eliminar.");
	}
});

$('.mod').click(function() {
	var rId = oGridC.getSelectedRowId();


	var cantidad = parseInt($('#cantidad').val());
	var precio_unitario = parseFloat(unformatMoney($('#precio_unitario').val()));
	var tipo_unidad = $('#tipo_unidad').val();
	var comboDescripcion = $('#descripcion').val();
	var descripcion = $('#sDescripcion').val();
	var subtotal = roundNumber(cantidad * precio_unitario, 2);

	if (cantidad != '' && precio_unitario != '' && tipo_unidad != '' && descripcion != '') {

		if ($('#fTasa_iva').val() == '') {
			alert("Se debe ingresar un valor para el IVA.");
			return false;
		} else
		if (cantidad == 0) {
			alert("La cantidad debe ser mayor a cero.");
			return false;
		} else
		if (precio_unitario == 0) {
			alert("El precio debe ser mayor a cero.");
			return false;
		}

		var rInd = (oGridC.getRowIndex(rId));
		oGridC.deleteRow(rId);
		oGridC.addRow(rId, [cantidad, descripcion, tipo_unidad, formatMoney(precio_unitario), formatMoney(subtotal)], rInd);
		onEditRow();
		
		$('#cantidad,#precio_unitario').val(0).blur();
		$('#tipo_unidad').val('');
		$('#sDescripcion').val('');
		$('#descripcion').val(0).focus();
	} else {
		alert("Se deben ingresar todos los campos.");
	}
});

function onEditRow() {
	var subtotal = 0;
	var iva_total = 0;
	var retencion_iva = parseFloat(unformatMoney($('#iva_retenido').val()));
	var total = 0;

	var num = oGridC.getRowsNum();
	for (var i = 1; i <= num; i++) {
		subtotal += parseFloat(unformatMoney(oGridC.cells(i, 4).getValue()));
	}
	
	iva_total = roundNumber(subtotal * ($("#fTasa_iva").val() / 100), 2);
	total = roundNumber(iva_total + subtotal - retencion_iva, 2);

	$("#subtotal").val(subtotal);
	$("#iva_total").val(iva_total);
	$("#total").val(total);
	
	setFormats();
}

// Función que ejecuta la acción de agregar un cliente.
//$('#addCliente').click(function() {
//	//baseURL = $(this).attr('base_url');
//
//	$.post($(this).attr('action'),
//			{},
//			function(html) {
//				baseURL = "/cfdi_qa/src/app/admonClientes/agregar/";
//				//loadJSFile(baseURL + 'jquery.form.js');
//				loadJSFile(baseURL + 'agregar.js');
//
//				oWin = $.newWindow({
//					id: 'wFetchRec',
//					title: 'Consultar Cliente',
//					height: 330,
//					width: 490,
//					content: html,
//					modal: true,
//					posx: 240,
//					posy: 110
//				});
//			}
//	);
//
//
//});
