/**
 *	Archivo para la funcionalidad Consultar sucursal
 **/

/**
 *Inicializacion de la plantilla consultar sucursal
 **/
$(document).ready(function() {
	initCssButtons();
	initInactiveControls();
	setFormats();
	
	$('#btnClose').click(
			function() {
				oWin.close();
			}
	);

	createGrid();
});

// Inicializacion del menu y submenu
function createGrid() {
	//-- Inicialización de Grid
	oGridC = new dhtmlXGridObject('dataGridConceptos');
	oGridC.setSkin("dhx_blue");
	oGridC.setHeader("Id,Cantidad, Descripci&oacute;n, Unidad, P. Unitario, Importe");
	oGridC.setInitWidths("0,80, 300, 95, 100, 120");
	oGridC.setColAlign("left,center,left, left, right, right");
	oGridC.setColTypes('ro,ro,ro,ro,ro,ro');

	oGridC.enableEditEvents(false, false, false);
	oGridC.init();

	loadGridRowsConceptos();
}


function loadGridRowsConceptos() {
	
	var id = $("#id_factura").val();	
	var id_formulario = oGrid.getUserData(id, 'tipo_formato');
	$.post($('#dataGridConceptos').attr('url'),
			{nId_factura: id, nTipo_formulario: id_formulario},
	function(response) {
		oGridC.parse(response.data, 'json');
	}, 'json');
}
function onEditRow() {
	var subtotal = 0;
	var iva_total = 0;
	var total = 0;

	var num = oGridC.getRowsNum();
	for (var i = 0; i < num; i++) {
		subtotal += parseFloat(oGridC.cells(oGridC.getRowId(i), 5).getValue());
	}
	iva_total = subtotal * ($("#fTasa_iva").val() / 100);
	total = iva_total + subtotal;

	subtotal = addCommas(subtotal.toFixed(2));
	iva_total = addCommas(iva_total.toFixed(2));
	total = addCommas(total.toFixed(2));


	$("#subtotal").val(subtotal);
	$("#iva_total").val(iva_total);
	$("#total").val(total);
}
function addCommas(nStr) {
	nStr += '';
	x = nStr.split('.');
	x1 = x[0];
	x2 = x.length > 1 ? '.' + x[1] : '';
	var rgx = /(\d+)(\d{3})/;
	while (rgx.test(x1)) {
		x1 = x1.replace(rgx, '$1' + ',' + '$2');
	}
	return x1 + x2;
}