/**
 *	Archivo para la funcionalidad Editar sucursal
 **/

/**
 *Inicializacion de la plantilla editar sucursal
 **/
$(document).ready(
		function() {
			initCssButtons();
			initInactiveControls();
			setFormats();
			comboDynamic();

			$('#btnClose').click(
					function() {
						if (confirm("Confirme para salir")) {
							loadGridRows();
							oWin.close();
						}
					}
			);
			createGrid();
			$('#btnEdit').click(saveInfo);
			$('#cantidad,#precio_unitario').val(0);
			$('#cantidad,.money').blur();
		}
);

/**
 * Funcion que guarda la informacion capturada por el usuario
 **/
function saveInfo() {
	if ($('#sReceptor').val() == '0') {
		alert('Se debe elegir un cliente.');
		return false;
	}
	
	if ($('#sForma_pago').val() == '0') {
		alert('Se debe elegir una Forma de Pago.');
		return false;
	}
	if ($('#sMetodo_pago').val() == '0') {
		alert('Se debe elegir un Metodo de Pago.');
		return false;
	}

	//-- Valida IVA vs Retencion IVA
	var iva = parseFloat(unformatMoney($('#iva_total').val()));
	var retencion_iva = parseFloat(unformatMoney($('#iva_retenido').val()));

	if (retencion_iva > iva) {
		$('#iva_retenido').focus();
		alert('Retención de IVA no puede ser mayor a IVA de la factura.');
		return;
	}

	var array_str = "";

//	if ($("#digitos_tarjeta").val() == '') {
//		$("#nDigitos_tarjeta").val(0);
//	} else {
	$("#nDigitos_tarjeta").val($("#digitos_tarjeta").val());
//	}
	var num = oGridCEdit.getRowsNum();
	var tasa_iva = $("#fTasa_iva").val();
	//Se obtienen los valores de la tabla de conceptos
	var arr = new Array();
	oGridCEdit.forEachRow(function(id) {
		array_str += oGridCEdit.cells(id, 1).getValue() + "[,] "
				+ oGridCEdit.cells(id, 2).getValue() + "[,] "
				+ oGridCEdit.cells(id, 3).getValue() + "[,] "
				+ unformatMoney(oGridCEdit.cells(id, 4).getValue()) + "[,] "
				+ tasa_iva + "[,] "
				+ "0.0[,] "
				+ "0.0[,] "
				+ "0.0[,] "
				+ "0.0[,] "
				+ unformatMoney(oGridCEdit.cells(id, 5).getValue()) + "[,] "
				+ "0.0[-] ";
	});

	$("#lista_conceptos").val(array_str);

	$.post(
			$('#btnEdit').attr('url'),
			$('#frmEditComprobante').serializeArray(),
			function(response) {
				if (response.ok) {
					successfulOperation(response.msg);
					loadGridRows();
					oWin.close(true);
				} else {
					$('.error').removeClass('error');
					$(response.error.ids).prev().filter('label').addClass('error');
					alert(response.error.msg);
				}
			},
			'json'
			);
}

//$('.comboListCliente').change(function() {
//	var source = this;
//	//Se envia el post //AJAX
//	$.post(
//			//Se especifica que el elemento asignado "(this)" ejecute lo que esta en el action
//			$(this).attr('action'),
//			//Se envia el(los) parametro(s)
//					{id_cliente: $(this).val()},
//			//lo que retorne despues de la ejecución (es decir "response") se asigna a los elementos
//			function(response) {
//				var comboCliente = $(source).closest('.comboCliente').find('.comboSucursal');
//				comboCliente.html(response.comboSucursal);
//				comboCliente.val(0);
//
//				$('#fTasa_Iva').val(response.fTasa_Iva);
//
//				$('.comboForma').html(response.comboModoPago);
//
//				$('.comboForma').change(function() {
//					var selec = $(".comboForma option:selected").html();
//					if (selec == 'Tarjeta de Crédito' || selec == 'Tarjeta de Debito') {
//						$('#digitos_tarjeta').removeAttr('disabled');
//					} else {
//						$('#digitos_tarjeta').attr('disabled', 'disabled');
//					}
//				});
//			}, 'json')
//		});
//
$('#sMetodo_pago').change(function() {
	$.post(
			//Se especifica que el elemento asignado "(this)" ejecute lo que esta en el action
			$(this).attr('action'),
			//Se envia el(los) parametro(s)
					{id_metodo: $(this).val()},
			function(response) {
				if (response.digitos_tarjeta == 1) {
					$('#digitos_tarjeta').removeAttr('disabled');
				} else {
					$('#digitos_tarjeta').attr('disabled', 'disabled').val('');
				}
			},
					'json');
		}
);


$('.comboSucursal').change(
		function() {
			$.post(
					//Se especifica que el elemento asignado "(this)" ejecute lo que esta en el action
					$(this).attr('action'),
					//Se envia el(los) parametro(s)
							{id_sucursal: $(this).val()},
					function(response) {
						$('#fTasa_iva').val(response.fTasa_Iva);
						onEditRow();
					},
							'json'
							);
				}
		);


		$('.comboDescripcion').change(function() {
			var id = ($('.comboDescripcion').val());
			var selec = $(".comboDescripcion option:selected").html();
			$("#sDescripcion").val(selec.toUpperCase());

			$.post($('.comboDescripcion').attr('url'),
					{},
					function(response) {
						var cant = response.listProductoServicio.length;
						for (var i = 0; i < cant; i++) {
							if (id == response.listProductoServicio[i].id_producto_servicio) {
								$("#precio_unitario").val(response.listProductoServicio[i].precio_unitario).blur();
								$("#tipo_unidad").val(response.listProductoServicio[i].nombre_medida);
								$('#cantidad').val(1).focus();
							}
						}
					}, 'json');
		});

		$('#iva_total,#iva_retenido').change(
				function() {
					var subtotal = parseFloat(unformatMoney($('#subtotal').val()));
					var iva = parseFloat(unformatMoney($('#iva_total').val()));
					var retencion_iva = parseFloat(unformatMoney($('#iva_retenido').val()));
					var total = roundNumber(subtotal + iva - retencion_iva, 2);

					$('#total').val(total).blur();
				}
		);

// Inicializacion del menu y submenu
		function createGrid() {
			//-- Inicialización de Grid
			oGridCEdit = new dhtmlXGridObject('dataGridConceptos');
			oGridCEdit.setSkin("dhx_blue");
			oGridCEdit.setHeader("Id,Cantidad, Descripcion, Unidad, P. Unitario, Importe");
			oGridCEdit.setInitWidths("0,80, 300, 95, 100, 120");
			oGridCEdit.setColAlign("left,center,left, left, right, right");
			oGridCEdit.setColTypes('ro,ro,ro,ro,ro,ro');
//	oGridCEdit.enableMathEditing(false);
//	oGridCEdit.setMathRound(2);

			oGridCEdit.enableEditEvents(false, false, false);
			oGridCEdit.init();

			oGridCEdit.attachEvent("onRowSelect", function(id, ind) {
				$("#cantidad").val(oGridCEdit.cells(id, 1).getValue());
				$("#precio_unitario").val(oGridCEdit.cells(id, 4).getValue());
				$("#sDescripcion").val(oGridCEdit.cells(id, 2).getValue());
				$("#tipo_unidad").val(oGridCEdit.cells(id, 3).getValue());
			});

			loadGridRowsConceptos();
		}

		function loadGridRowsConceptos() {
			var id = oGrid.getSelectedId();
			var id_formulario = oGrid.getUserData(id, 'tipo_formato');
			$("#id_factura").val(id);
			$.post($('#dataGridConceptos').attr('url'),
					{nId_factura: id, nTipo_formulario: id_formulario},
			function(response) {
				oGridCEdit.parse(response.data, 'json');
				var subtotal = 0;
				var iva_total = 0;
				var iva_retenido = 0;
				var total = 0;

				subtotal = formatMoney(response.factura.subtotal);
				subtotal = subtotal.substring(0, subtotal.length - 4);

				iva_total = formatMoney(formatMoney(response.factura.iva));
				iva_total = iva_total.substring(0, iva_total.length - 4);

				iva_retenido = formatMoney(formatMoney(response.factura.retencion_iva));
				iva_retenido = iva_retenido.substring(0, iva_retenido.length - 4);

				total = formatMoney(formatMoney(response.factura.total));
				total = total.substring(0, total.length - 4);

				$('#subtotal').val(subtotal);
				$('#iva_total').val(iva_total);
				$('#iva_retenido').val(iva_retenido);
				$('#total').val(total);
//				$('.money').blur();
			}, 'json');
		}


		$('.add').click(function() {
			var cantidad = $('#cantidad').val();
			var precio_unitario = parseFloat(unformatMoney($('#precio_unitario').val()));
			var tipo_unidad = $('#tipo_unidad').val();
			var comboDescripcion = $('#descripcion').val();
			var descripcion = $('#sDescripcion').val();
			var subtotal = roundNumber(cantidad * precio_unitario, 2);

			if (cantidad != '' && precio_unitario != '' && tipo_unidad != '' && comboDescripcion != '0') {

				if ($('#fTasa_iva').val() == '') {
					alert("Se debe ingresar un valor para el IVA.");
					return false;
				} else
				if (cantidad == 0) {
					alert("La cantidad debe ser mayor a cero.");
					return false;
				} else
				if (precio_unitario == 0) {
					alert("El precio debe ser mayor a cero.");
					return false;
				}
				var new_id = oGridCEdit.getRowsNum() + 1;


				oGridCEdit.addRow(new_id, [new_id, cantidad, descripcion, tipo_unidad, formatMoney(precio_unitario), formatMoney(subtotal)], 0);
				onEditRow();

				$('#cantidad,#precio_unitario').val(0).blur();
				$('#tipo_unidad').val('');
				$('#sDescripcion').val('');
				$('#descripcion').val(0).focus();
			} else {
				alert("Se deben ingresar todos los campos.");
			}
		});

		$('.del').click(function() {
			var rId = oGridCEdit.getSelectedRowId();
			if (rId !== undefined) {
				oGridCEdit.deleteRow(rId);
				onEditRow();

				$('#cantidad,#precio_unitario').val(0).blur();
				$('#tipo_unidad').val('');
				$('#sDescripcion').val('');
				$('#descripcion').val(0).focus();
			} else {
				alert("Selecciona la fila a eliminar.");
			}
		});

		$('.mod').click(function() {
			var rId = oGridCEdit.getSelectedRowId();


			var cantidad = parseInt($('#cantidad').val());
			var precio_unitario = parseFloat(unformatMoney($('#precio_unitario').val()));
			var tipo_unidad = $('#tipo_unidad').val();
			var comboDescripcion = $('#descripcion').val();
			var descripcion = $('#sDescripcion').val();
			var subtotal = roundNumber(cantidad * precio_unitario, 2);

			if (cantidad != '' && precio_unitario != '' && tipo_unidad != '' && descripcion != '') {

				if ($('#fTasa_iva').val() == '') {
					alert("Se debe ingresar un valor para el IVA.");
					return false;
				} else
				if (cantidad == 0) {
					alert("La cantidad debe ser mayor a cero.");
					return false;
				} else
				if (precio_unitario == 0) {
					alert("El precio debe ser mayor a cero.");
					return false;
				}

				var rInd = (oGridCEdit.getRowIndex(rId));
				oGridCEdit.deleteRow(rId);
				oGridCEdit.addRow(rId, [rId, cantidad, descripcion, tipo_unidad, formatMoney(precio_unitario), formatMoney(subtotal)], rInd);
				onEditRow();

				$('#cantidad,#precio_unitario').val(0).blur();
				$('#tipo_unidad').val('');
				$('#sDescripcion').val('');
				$('#descripcion').val(0).focus();
			} else {
				alert("Se deben ingresar todos los campos.");
			}
		});

		function onEditRow() {
			var subtotal = 0;
			var iva_total = 0;
			var retencion_iva = parseFloat(unformatMoney($('#iva_retenido').val()));
			var total = 0;

			var num = oGridCEdit.getRowsNum();
			for (var i = 0; i < num; i++) {
				subtotal += parseFloat(unformatMoney(oGridCEdit.cells(oGridCEdit.getRowId(i), 5).getValue()));
			}
			iva_total = roundNumber(subtotal * ($("#fTasa_iva").val() / 100), 2);
			total = roundNumber(iva_total + subtotal - retencion_iva, 2);

			$("#subtotal").val(formatMoney(subtotal));
			$("#iva_total").val(iva_total);
			$("#total").val(formatMoney(total));

			setFormats();
		}