/**
 *	Archivo para la funcionalidad Consultar sucursal
 **/

/**
 *Inicializacion de la plantilla consultar sucursal
 **/
$(document).ready(function() {
	initCssButtons();
	initInactiveControls();
	setFormats();

	$('#btnClose').click(
			function() {
				oWin.close();
			}
	);
	createGrid();
});

// Inicializacion del menu y submenu
function createGrid() {
	//-- Inicialización de Grid
	oGridC = new dhtmlXGridObject('dataGridConceptos');
	oGridC.setSkin("dhx_blue");
	oGridC.setHeader("Id,Cantidad,Descripcion,Unidad,P. Unitario,Tasa IVA,IEPS,Ret. IVA,Ret. ISR,Ret. IEPS,Importe, IVA,tasa_ieps,0,iva_exento");
	oGridC.setInitWidths("0,65,215,65,80,80,80,80,80,80,90,0,0,0,100");
	oGridC.setColAlign("center,center,left,left,left,left,left,left,left,right,right,right,right,left,left");
	oGridC.setColTypes('ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro');
	oGridC.enableEditEvents(false, false, false);
	oGridC.init();

	oGridC.attachEvent("onRowSelect", function(id, ind) {
		var cantidad = oGridC.cells(id, 1).getValue();
		var precio_unitario = parseFloat(unformatMoney(oGridC.cells(id, 4).getValue()));
		var iva = parseFloat((unformatMoney(oGridC.cells(id, 11).getValue()) / cantidad)).toFixed(6);
		var ieps = parseFloat(unformatMoney(oGridC.cells(id, 6).getValue()));
		var ret_iva = parseFloat(unformatMoney(oGridC.cells(id, 7).getValue()));
		var ret_isr = parseFloat(unformatMoney(oGridC.cells(id, 8).getValue()));
		var ret_ieps = parseFloat(unformatMoney(oGridC.cells(id, 9).getValue()));
		var porc_ret_ieps = roundNumber((ret_ieps * 100) / (precio_unitario + ieps), 6);
		var porc_ret_iva = roundNumber((ret_iva * 100) / (precio_unitario + ieps), 6);
		var porc_ret_isr = roundNumber((ret_isr * 100) / (precio_unitario + ieps), 6);
		var tasa_ieps = parseFloat(oGridC.cells(id, 12).getValue());
		var iva_exento = parseFloat(oGridC.cells(id, 14).getValue());
		if (iva_exento == 1) {
			$("#iva_exento").prop("checked", true);
		}else{
			$("#iva_exento").prop("checked", false);
		}
		$("#cantidad").val(oGridC.cells(id, 1).getValue());
		$("#precio_unitario").val(formatMoney(precio_unitario));
		$("#sDescripcion").val(oGridC.cells(id, 2).getValue());
		$("#tipo_unidad").val(oGridC.cells(id, 3).getValue());
		$("#tasa_iva").val(parseFloat(unformatMoney(oGridC.cells(id, 5).getValue())).toFixed(6));
		$("#iva").val(iva);
		$("#ieps").val(ieps);
		$("#tasa_ieps").val(tasa_ieps.toFixed(6));
		$("#ret_iva").val(ret_iva);
		$("#porc_ret_iva").val(porc_ret_iva.toFixed(6));
		$("#ret_isr").val(ret_isr);
		$("#porc_ret_isr").val(porc_ret_isr.toFixed(6));
		$("#ret_ieps").val(ret_ieps);
		$("#porc_ret_ieps").val(porc_ret_ieps.toFixed(6));
	});

	loadGridRowsConceptos();
}


function loadGridRowsConceptos() {

	var id = oGrid.getSelectedId();
	$("#id_factura").val(id);
	$.post($('#dataGridConceptos').attr('url'),
			{nId_factura: id},
	function(response) {
		oGridC.parse(response.data, 'json');

		var subtotal = formatMoney(response.factura.subtotal);
		subtotal = subtotal.substring(0, subtotal.length - 4);
		var iva_total = formatMoney(response.factura.iva);
		iva_total = iva_total.substring(0, iva_total.length - 4);
		var ret_iva = formatMoney(response.factura.retencion_iva);
		ret_iva = ret_iva.substring(0, ret_iva.length - 4);
		var ret_isr = formatMoney(response.factura.retencion_isr);
		ret_isr = ret_isr.substring(0, ret_isr.length - 4);
		var ret_ieps = formatMoney(response.factura.retencion_ieps);
		ret_ieps = ret_ieps.substring(0, ret_ieps.length - 4);
		var ieps_total = formatMoney(response.factura.ieps);
		ieps_total = ieps_total.substring(0, ieps_total.length - 4);
		var total = formatMoney(response.factura.total);
		total = total.substring(0, total.length - 4);

		$('#subtotal').val(subtotal);
		$('#iva_total').val(iva_total);
		$('#retencion_iva_total').val(ret_iva);
		$('#retencion_isr_total').val(ret_isr);
		$('#retencion_ieps_total').val(ret_ieps);
		$('#ieps_total').val(ieps_total);
		$('#total').val(total);
		$('.money').blur();

	}, 'json');
}