/**
 *	Archivo para la funcionalidad Editar sucursal
 **/

/**
 *Inicializacion de la plantilla editar sucursal
 **/
$(document).ready(function() {
	initCssButtons();
	initInactiveControls();
	setFormats();
	comboDynamic();

	$('#btnClose').click(
			function() {
				if (confirm("Confirme para salir")) {
					loadGridRows();
					oWin.close();
				}
			}
	);
	createGrid();
	$("#add_note").click(agregarNota);
	$('#btnEdit').click(saveInfo);
	$('#cantidad,#precio_unitario').val(0);
	$('#cantidad,.money').blur();

	doOnLoad();

});

/**
 * Funcion que guarda la informacion capturada por el usuario
 **/
function saveInfo() {
	if ($('#sReceptor').val() == '0') {
		alert('Se debe elegir un cliente.');
		return false;
	}
	if ($('#sForma_pago').val() == '0') {
		alert('Se debe elegir una Forma de Pago.');
		return false;
	}
	if ($('#sMetodo_pago').val() == '0') {
		alert('Se debe elegir un Metodo de Pago.');
		return false;
	}

	//-- Valida IVA vs Retencion IVA
	var iva = parseFloat(unformatMoney($('#iva_total').val()));
	var retencion_iva = parseFloat(unformatMoney($('#retencion_iva_total').val()));

	if (retencion_iva > iva) {
		$('#iva_retenido').focus();
		alert('Retención de IVA no puede ser mayor a IVA de la factura.');
		return;
	}
	
	var ieps = parseFloat(unformatMoney($('#ieps_total').val()));
	var retencion_ieps = parseFloat(unformatMoney($('#retencion_ieps_total').val()));
	if (retencion_ieps > ieps) {
		alert('Retención de IEPS no puede ser mayor al IEPS de la factura.');
		return;
	}
	
	var array_str = "";

	$("#nDigitos_tarjeta").val($("#digitos_tarjeta").val());
	var num = oGridCEdit.getRowsNum();

	//Se obtienen los valores de la tabla de conceptos
	var arr = new Array();
	oGridCEdit.forEachRow(function(id) {
		array_str += oGridCEdit.cells(id, 1).getValue() + "[,] "				//Cantidad
				+ oGridCEdit.cells(id, 2).getValue() + "[,] "					//Descripcion
				+ oGridCEdit.cells(id, 3).getValue() + "[,] "					//Unidad
				+ unformatMoney(oGridCEdit.cells(id, 4).getValue()) + "[,] "	//Precion unitario
				+ oGridCEdit.cells(id, 5).getValue() + "[,] "					//Tasa Iva
				+ unformatMoney(oGridCEdit.cells(id, 11).getValue()) + "[,] "	//IVA		
				+ unformatMoney(oGridCEdit.cells(id, 6).getValue()) + "[,] "	//IEPS		
				+ unformatMoney(oGridCEdit.cells(id, 7).getValue()) + "[,] "	//Ret. IVA
				+ unformatMoney(oGridCEdit.cells(id, 8).getValue()) + "[,] "	//Ret. ISR
				+ unformatMoney(oGridCEdit.cells(id, 9).getValue()) + "[,] "	//Ret. IEPS
				+ unformatMoney(oGridCEdit.cells(id, 10).getValue()) + "[,] "	//Importe
				+ unformatMoney(oGridCEdit.cells(id, 12).getValue()) + "[,] "	//tasa_ieps
				+ unformatMoney(oGridCEdit.cells(id, 14).getValue()) + "[-] ";	//iva_exento
	});
	$("#lista_conceptos").val(array_str);
	
	$.post(
			$('#btnEdit').attr('url'),
			$('#frmEditComprobante').serializeArray(),
			function(response) {
				if (response.ok) {
					successfulOperation(response.msg);
					loadGridRows();
					oWin.close(true);
				} else {
					$('.error').removeClass('error');
					$(response.error.ids).prev().filter('label').addClass('error');
					alert(response.error.msg);
				}
			},
			'json'
			);
}

$('#sMetodo_pago').change(function() {
	$.post(
			//Se especifica que el elemento asignado "(this)" ejecute lo que esta en el action
			$(this).attr('action'),
			//Se envia el(los) parametro(s)
					{id_metodo: $(this).val()},
			function(response) {
				if (response.digitos_tarjeta == 1) {
					$('#digitos_tarjeta').removeAttr('disabled');
				} else {
					$('#digitos_tarjeta').attr('disabled', 'disabled').val('');
				}
			},
					'json');
		}
);

$('#precio_unitario').change(function() {
	CalculaValores();
});

$('#tasa_iva').change(function() {
	CalculaValores();
});

$('#tasa_ieps').change(function() {
	CalculaValores();
});

$('#porc_ret_iva').change(function() {
	CalculaValores();
});
$('#ret_iva').change(function() {
	CalculaValores("retencion_iva");
});

$('#porc_ret_isr').change(function() {
	CalculaValores();
});
$('#ret_isr').change(function() {
	CalculaValores("retencion_isr");
});

$('#porc_ret_ieps').change(function() {
	CalculaValores();
});
$('#ret_ieps').change(function() {
	CalculaValores("retencion_ieps");
});

$('#tipo_ieps').change(function() {
	CalculaValores();
});
$('#iva_exento').change(function() {
	if($("#cantidad").val() > 0){
		CalculaValores();
	}
});


// Inicializacion del menu y submenu
function createGrid() {
	//-- Inicialización de Grid
	oGridCEdit = new dhtmlXGridObject('dataGridConceptos');
	oGridCEdit.setSkin("dhx_blue");
	oGridCEdit.setHeader("Id,Cantidad,Descripcion,Unidad,P. Unitario,Tasa IVA,IEPS,Ret. IVA,Ret. ISR,Ret. IEPS,Importe, IVA,tasa_ieps,id_unidad,iva_exento");
	oGridCEdit.setInitWidths("0,65,215,65,80,80,80,80,80,80,90,0,0,0,0");
	oGridCEdit.setColAlign("center,center,left,left,left,left,left,left,left,right,right,right,right,left,left");
	oGridCEdit.setColTypes('ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro,ro');
	oGridCEdit.setColSorting("int,int,str,str,int,str,int,int,int,int,int,int,int,int,int");
	oGridCEdit.enableResizing("false,false,false,false,false,false,false,false,false,false,false,false,false,false,false");
	oGridCEdit.enableStableSorting(false);
	oGridCEdit.enableEditEvents(false, false, false);
	oGridCEdit.init();

	oGridCEdit.attachEvent("onRowSelect", function(id, ind) {
		var cantidad = oGridCEdit.cells(id, 1).getValue();
		var precio_unitario = parseFloat(unformatMoney(oGridCEdit.cells(id, 4).getValue()));
		var iva = parseFloat((unformatMoney(oGridCEdit.cells(id, 11).getValue()) / cantidad)).toFixed(6);
		var ieps = parseFloat(unformatMoney(oGridCEdit.cells(id, 6).getValue()));
		var ret_iva = parseFloat(unformatMoney(oGridCEdit.cells(id, 7).getValue()));
		var ret_isr = parseFloat(unformatMoney(oGridCEdit.cells(id, 8).getValue()));
		var ret_ieps = parseFloat(unformatMoney(oGridCEdit.cells(id, 9).getValue()));
		var porc_ret_iva = roundNumber((ret_iva * 100) / (precio_unitario + ieps), 6);
		var porc_ret_isr = roundNumber((ret_isr * 100) / (precio_unitario + ieps), 6);
		var porc_ret_ieps = roundNumber((ret_ieps * 100) / (precio_unitario + ieps), 6);
		var tasa_ieps = parseFloat(oGridCEdit.cells(id, 12).getValue());
		var iva_exento = parseFloat(oGridCEdit.cells(id, 14).getValue());
		
		if (iva_exento == 1) {
			$("#iva_exento").prop("checked", true);
		}else{
			$("#iva_exento").prop("checked", false);
		}
		
		$("#cantidad").val(oGridCEdit.cells(id, 1).getValue());
		$("#precio_unitario").val(formatMoney(precio_unitario));
		$("#sDescripcion").val(oGridCEdit.cells(id, 2).getValue());
		$("#tipo_unidad").val(oGridCEdit.cells(id, 13).getValue());
		$("#tasa_iva").val(parseFloat(unformatMoney(oGridCEdit.cells(id, 5).getValue())).toFixed(6));
		$("#iva").val(iva);
		$("#ieps").val(ieps);
		$("#tasa_ieps").val(tasa_ieps.toFixed(6));
		$("#ret_iva").val(ret_iva);
		$("#porc_ret_iva").val(porc_ret_iva.toFixed(6));
		$("#ret_isr").val(ret_isr);
		$("#porc_ret_isr").val(porc_ret_isr.toFixed(6));
		$("#ret_ieps").val(ret_ieps);
		$("#porc_ret_ieps").val(porc_ret_ieps.toFixed(6));
	});

	loadGridRowsConceptos();
}

function loadGridRowsConceptos() {
	var id = oGrid.getSelectedId();
	$("#id_factura").val(id);
	$.post($('#dataGridConceptos').attr('url'),
			{nId_factura: id},
	function(response) {
		oGridCEdit.parse(response.data, 'json');

		var subtotal = formatMoney(response.factura.subtotal);
		subtotal = subtotal.substring(0, subtotal.length - 4);
		var iva_total = formatMoney(response.factura.iva);
		iva_total = iva_total.substring(0, iva_total.length - 4);
		var ret_iva = formatMoney(response.factura.retencion_iva);
		ret_iva = ret_iva.substring(0, ret_iva.length - 4);
		var ret_isr = formatMoney(response.factura.retencion_isr);
		ret_isr = ret_isr.substring(0, ret_isr.length - 4);
		var ret_ieps = formatMoney(response.factura.retencion_ieps);
		ret_ieps = ret_ieps.substring(0, ret_ieps.length - 4);
		var ieps_total = formatMoney(response.factura.ieps);
		ieps_total = ieps_total.substring(0, ieps_total.length - 4);
		var total = formatMoney(response.factura.total);
		total = total.substring(0, total.length - 4);

		$('#subtotal').val(subtotal);
		$('#iva_total').val(iva_total);
		$('#retencion_iva_total').val(ret_iva);
		$('#retencion_isr_total').val(ret_isr);
		$('#retencion_ieps_total').val(ret_ieps);
		$('#ieps_total').val(ieps_total);
		$('#total').val(total);
		$('.money').blur();
	}, 'json');
}


$('.add').click(function() {
	var cantidad = $('#cantidad').val();
	var precio_unitario = (parseFloat(unformatMoney($('#precio_unitario').val())));
	var tipo_unidad = $('#tipo_unidad option:selected').html();
	var id_unidad = $('#tipo_unidad').val();
	var descripcion = $('#sDescripcion').val();
	var tasa_iva = roundNumber($("#tasa_iva").val(), 2) + "%";
	var iva = parseFloat($("#iva").val());
	var ieps = parseFloat($("#ieps").val());
	var retencion_iva = parseFloat($("#ret_iva").val());
	var retencion_isr = parseFloat($("#ret_isr").val());
	var retencion_ieps = parseFloat($("#ret_ieps").val());
	var tasa_ieps = parseFloat($("#tasa_ieps").val());
	var iva_exento = $("#iva_exento").val();
	if ($("#iva_exento").is(':checked')) {
		iva_exento = 1;
	}else{
		iva_exento = 0;
	}
	
	var subtotal = 0;
	
	if ($('#fTasa_iva').val() == '') {
		alert("Se debe ingresar un valor para el IVA.");
		return false;
	}
	if (cantidad == 0) {
		alert("La cantidad debe ser mayor a cero.");
		return false;
	}
	if (precio_unitario == 0) {
		alert("El precio debe ser mayor a cero.");
		return false;
	}
	var new_id = oGridCEdit.getRowId(oGridCEdit.getRowsNum() - 1);
	new_id = parseInt(new_id) + 1;

	subtotal = roundNumber((precio_unitario) * cantidad, 2);

	precio_unitario = formatMoney(precio_unitario);

	ieps = formatMoney(roundNumber((ieps * cantidad), 6));

	retencion_iva = formatMoney(roundNumber(retencion_iva, 6));

	retencion_isr = formatMoney(roundNumber(retencion_isr, 6));
	
	retencion_ieps = formatMoney(roundNumber(retencion_ieps, 6));

	subtotal = formatMoney(roundNumber(subtotal, 6));

	iva = iva * cantidad;

	oGridCEdit.addRow(new_id,
			[new_id,
			cantidad,
			descripcion,
			tipo_unidad,
			formatMoney(precio_unitario),
			tasa_iva,
			ieps,
			retencion_iva,
			retencion_isr,
			retencion_ieps,
			subtotal,
			roundNumber(iva, 2),
			tasa_ieps,
			id_unidad,
			iva_exento]
			, 0);

	onEditRow();

	$('#cantidad,#precio_unitario').val(0).blur();
	$('#tipo_unidad').val('');
	$('#sDescripcion').val('');
	$('#cantidad').val('');
	$('#tasa_iva').val('');
	$('#tasa_ieps').val('');
	$('#porc_ret_iva').val('');
	$('#porc_ret_isr').val('');
	$('#porc_ret_ieps').val('');
	$('#iva').val('');
	$('#ieps').val('');
	$('#ret_iva').val('');
	$('#ret_isr').val('');
	$('#ret_ieps').val('');
	$('#precio_unitario').val('');
	$('#descripcion').val(0);
	$('#descripcion').focus();
	$("#iva_exento").prop('checked', false);

});

$('.del').click(function() {
	var rId = oGridCEdit.getSelectedRowId();
	if (rId !== undefined) {
		oGridCEdit.deleteRow(rId);
		onEditRow();

		$('#cantidad,#precio_unitario').val(0).blur();
		$('#tipo_unidad').val('');
		$('#sDescripcion').val('');
		$('#descripcion').val(0).focus();
	} else {
		alert("Selecciona la fila a eliminar.");
	}
});

$('.mod').click(function() {
	var rId = oGridCEdit.getSelectedRowId();
	var cantidad = $('#cantidad').val();
	var precio_unitario = (parseFloat(unformatMoney($('#precio_unitario').val())));
	var tipo_unidad = $('#tipo_unidad option:selected').html();
	var id_unidad = $('#tipo_unidad').val();
	var descripcion = $('#sDescripcion').val();
	var tasa_iva = roundNumber($("#tasa_iva").val(), 2) + "%";
	var iva = parseFloat($("#iva").val());
	var ieps = parseFloat($("#ieps").val());
	var retencion_iva = parseFloat($("#ret_iva").val());
	var retencion_isr = parseFloat($("#ret_isr").val());
	var retencion_ieps = parseFloat($("#ret_ieps").val());
	var tasa_ieps = (roundNumber($("#tasa_ieps").val(), 2)).toFixed(6);
	var iva_exento = 0;
	if ($("#iva_exento").is(':checked')) {
		iva_exento = 1;
	}
	var subtotal = 0;

	if (cantidad == 0) {
		alert("La cantidad debe ser mayor a cero.");
		return false;
	}

	if (precio_unitario == 0) {
		alert("El precio debe ser mayor a cero.");
		return false;
	}

	subtotal = roundNumber((precio_unitario) * cantidad, 2);

	precio_unitario = formatMoney(precio_unitario);

	ieps = formatMoney(ieps);

	retencion_iva = formatMoney(retencion_iva);

	retencion_isr = formatMoney(retencion_isr);
	
	retencion_ieps = formatMoney(retencion_ieps);

	subtotal = formatMoney(subtotal);

	iva = iva * cantidad;

	var rInd = (oGridCEdit.getRowIndex(rId));
	oGridCEdit.deleteRow(rId);

	oGridCEdit.addRow(rId,
			[rId, cantidad,
				descripcion,
				tipo_unidad,
				precio_unitario,
				tasa_iva,
				ieps,
				retencion_iva,
				retencion_isr,
				retencion_ieps,
				subtotal,
				roundNumber(iva, 2),
				tasa_ieps, 
				id_unidad,
				iva_exento
			]
			, rInd);
	onEditRow();

	$('#cantidad,#precio_unitario').val(0).blur();
	$('#tipo_unidad').val('');
	$('#sDescripcion').val('');
	$('#cantidad').val('');
	$('#tasa_iva').val('');
	$('#tasa_ieps').val('');
	$('#porc_ret_iva').val('');
	$('#porc_ret_isr').val('');
	$('#porc_ret_ieps').val('');
	$('#iva').val('');
	$('#ieps').val('');
	$('#ret_iva').val('');
	$('#ret_isr').val('');
	$('#ret_ieps').val('');
	$('#precio_unitario').val('');

	$('#descripcion').val(0).focus();

});

function onEditRow() {
	var subtotal = 0;
	var iva_total = 0;
	var retencion_iva = 0;
	var retencion_isr = 0;
	var retencion_ieps = 0;
	var ieps_total = 0;
	var total = 0;
	var id = 0;
	var cantidad = 0;

	var num = oGridCEdit.getRowsNum();
	for (var i = 0; i < num; i++) {
		id = oGridCEdit.getRowId(i);
		cantidad = oGridCEdit.cells(id, 1).getValue();
		subtotal += parseFloat(unformatMoney(oGridCEdit.cells(id, 10).getValue()));
		retencion_iva += parseFloat(unformatMoney(oGridCEdit.cells(id, 7).getValue()));
		retencion_isr += parseFloat(unformatMoney(oGridCEdit.cells(id, 8).getValue()));
		retencion_ieps += parseFloat(unformatMoney(oGridCEdit.cells(id, 9).getValue()));
		ieps_total += (parseFloat(unformatMoney(oGridCEdit.cells(id, 6).getValue())))*cantidad;
		iva_total += parseFloat(unformatMoney(oGridCEdit.cells(id, 11).getValue()));
	}

	total = formatMoney(roundNumber((subtotal + ieps_total + iva_total) - retencion_iva - retencion_isr - retencion_ieps, 2));
	total = total.substring(0, total.length - 4);

	retencion_iva = formatMoney(roundNumber(retencion_iva, 2));
	retencion_iva = retencion_iva.substring(0, retencion_iva.length - 4);

	retencion_isr = formatMoney(roundNumber(retencion_isr, 2));
	retencion_isr = retencion_isr.substring(0, retencion_isr.length - 4);

	retencion_ieps = formatMoney(roundNumber(retencion_ieps, 2));
	retencion_ieps = retencion_ieps.substring(0, retencion_ieps.length - 4);

	ieps_total = formatMoney(roundNumber(ieps_total, 3));
	ieps_total = ieps_total.substring(0, ieps_total.length - 4);

	iva_total = formatMoney(roundNumber(iva_total, 2));
	iva_total = iva_total.substring(0, iva_total.length - 4);

	subtotal = formatMoney(roundNumber(subtotal, 2));
	subtotal = subtotal.substring(0, subtotal.length - 4);

	$("#retencion_iva_total").val(retencion_iva);
	$("#retencion_isr_total").val(retencion_isr);
	$("#retencion_ieps_total").val(retencion_ieps);
	$("#ieps_total").val(ieps_total);
	$("#iva_total").val(iva_total);
	$("#subtotal").val(subtotal);
	$("#total").val(total);

	setFormats();
}

function doOnLoad() {
	window.dhx_globalImgPath = "css/img/";
	var combo_productos = $("#descripcion").attr("url");
	var combo = new dhtmlXCombo("descripcion", "alfa", 200);
	combo.enableFilteringMode(true, combo_productos, true, false);
	combo.attachEvent("onChange", onSelectionChangeFunc);
}

function onSelectionChangeFunc() {
	var id = this.getSelectedValue();
	if (id != null) {

		$("#sDescripcion").val(this.getSelectedText());
		$.post($('.comboDescripcion').attr('url_inf'),
				{id_producto_servicio: id},
		function(response) {
			var precio_unitario = response.precio_unitario;
			var iva = response.iva;
			var tasa_iva = response.tasa_iva;
			var tasa_ieps = response.tasa_ieps;
			var ieps = response.ieps;
			var porc_ret_iva = response.retencion_iva;
			var porc_ret_isr = response.retencion_isr;
			var porc_ret_ieps = response.retencion_ieps;
			var ret_iva = response.ret_iva;
			var ret_isr = response.ret_isr;
			var ret_ieps = response.ret_ieps;

			$("#precio_unitario").val(formatMoney(precio_unitario));
			$("#tipo_unidad").val(response.id_unidad_medida);
			$("#tasa_iva").val(tasa_iva);
			$("#tasa_ieps").val(tasa_ieps);
			$("#porc_ret_iva").val(porc_ret_iva);
			$("#porc_ret_isr").val(porc_ret_isr);
			$("#porc_ret_ieps").val(porc_ret_ieps);
			$("#iva").val(roundNumber(iva, 6));
			$("#ret_iva").val(roundNumber(ret_iva, 6));
			$("#ret_isr").val(roundNumber(ret_isr, 6));
			$("#ret_ieps").val(roundNumber(ret_ieps, 6));
			$("#ieps").val(roundNumber(ieps, 6));
			$("#desglozar_iva").val(response.impuestos);
			$('#cantidad').val(1).focus();
		}, 'json');
		this.setComboValue('');
	}
}

function CalculaValores(opc) {
	var precio_unitario = parseFloat(unformatMoney($("#precio_unitario").val()));
	var tasa_ieps = parseFloat($("#tasa_ieps").val());
	var ieps_cant = parseFloat($("#ieps").val());
	var porc_ret_iva = parseFloat($("#porc_ret_iva").val());
	var retencion_iva = parseFloat($("#ret_iva").val());
	var porc_ret_isr = parseFloat($("#porc_ret_isr").val());
	var retencion_isr = parseFloat($("#ret_isr").val());
	var porc_ret_ieps = parseFloat($("#porc_ret_ieps").val());
	var retencion_ieps = parseFloat($("#ret_ieps").val());
	var tasa_iva = parseFloat($("#tasa_iva").val());
	var tipo_ieps = parseFloat($("#tipo_ieps").val());
	var iva = 0;

	//IEPS
	if (tipo_ieps == '1') {
		var aux = precio_unitario;
		precio_unitario = precio_unitario * ((tasa_ieps / 100) + 1);
		ieps_cant = precio_unitario - aux;
	} else {
		var aux = precio_unitario;
		precio_unitario = precio_unitario + tasa_ieps;
		ieps_cant = tasa_ieps;
	}

	//IVA
	iva = roundNumber((precio_unitario * ((tasa_iva / 100) + 1)), 6) - precio_unitario;

	if (opc == "retencion_iva") {
		//PORCENTAJE DE RETENCION DE IVA
		porc_ret_iva = (retencion_iva * 100) / precio_unitario;
	} else {
		//RETENCION IVA
		retencion_iva = (precio_unitario * ((porc_ret_iva / 100) + 1)) - precio_unitario;
	}

	if (opc == "retencion_isr") {
		//PORCENTAJE DE RETENCION DE ISR
		porc_ret_isr = (retencion_isr * 100) / precio_unitario;
	} else {
		//RETENCION ISR
		retencion_isr = roundNumber((precio_unitario * ((porc_ret_isr / 100) + 1)), 6) - precio_unitario;
	}
	
	if (opc == "retencion_ieps") {
		//PORCENTAJE DE RETENCION DE IEPS
		porc_ret_ieps = (retencion_ieps * 100) / precio_unitario;
	} else {
		//RETENCION IEPS
		retencion_ieps = roundNumber((precio_unitario * ((porc_ret_ieps / 100) + 1)), 6) - precio_unitario;
	}
	if ($("#iva_exento").is(':checked')) {
		$("#iva").val(roundNumber(0, 6));
		$("#tasa_iva").val(roundNumber(0, 6));
	}else{
		$("#iva").val(roundNumber(iva, 6));
	}
	
	$("#ret_iva").val(retencion_iva.toFixed(6));
	$("#porc_ret_iva").val(porc_ret_iva.toFixed(6));
	$("#ret_isr").val(roundNumber(retencion_isr, 6));
	$("#ret_ieps").val(roundNumber(retencion_ieps, 6));
	$("#porc_ret_isr").val(porc_ret_isr.toFixed(6));
	$("#porc_ret_ieps").val(porc_ret_ieps.toFixed(6));
	$("#ieps").val(roundNumber(ieps_cant, 6));
}

function agregarNota(id_option) {
	$.post(
			$('#add_note').attr('_url'),
			{
			},
			function(html) {
				var viewportWidth = parseInt($('body').innerWidth());
				loadJSFile(baseURL + 'editar/notas.js');
				oWinNote = $.newWindow(
						{
							id: 'conten_note',
							title: 'Editar Nota a Comprobante',
							height: 150,
							width: 500,
							content: html,
							modal: true,
							posx: Math.max((viewportWidth - 500) / 2, 10),
							posy: 50
						}
				);
			}
	);
}