<?php

/*
 * Genera el Pdf de la factura mediante su id.
 * 
 * @author Mario Cruz.
 */
require_once(FS_FRAMEWORK . 'mpdf/mpdf.php');
//require_once(FS_FRAMEWORK . 'variables.php');
//require_once(FS_FRAMEWORK . 'classes/Template.php');
require_once(FS_CLASSES . 'FacturasDAO.php');
require_once(FS_CLASSES . 'ConfiguracionCuentaDAO.php');
require_once(FS_CLASSES . 'PlantillasDAO.php');
require_once(FS_CLASSES . 'Municipios.php');
require_once(FS_CLASSES . 'functions.php');
require_once(FS_CLASSES . 'ClienteDAO.php');
require_once(FS_CLASSES . 'UsuariosDAO.php');
require_once(FS_CLASSES . 'SucursalDAO.php');

$cta = new ConfiguracionCuentaDAO();
$mun = new Municipios();
$fac = new FacturasDAO();
$oPtlla = new PlantillasDAO();
$cli = new ClienteDAO();
$emi = new UsuariosDAO();
$suc = new SucursalDAO();
$result = array();

$id_factura = $_REQUEST['nId_factura'];
$infoFac = $fac->obtenerInformacionFactura($id_factura);
$infoEmisor = reset($cta->cargaConfiguracionCuenta($infoFac['id_usuario']));
$res = $fac->getStatus($id_factura);
$infoReceptor = $cli->recuperarCliente($infoFac['id_cliente']);
$logotipo = ($infoEmisor['logotipo'] != '' ? FS_DATA_LOGOTIPOS . $infoEmisor['logotipo'] : '');
$receptor_municipio = array_shift($mun->obtenerMunicipio($infoEmisor['id_estado'], $infoEmisor['id_municipio']));
$emisor = $emi->recuperarUsuario($infoFac['id_usuario']);
$sucursal = $suc->recuperarSucursal($infoFac['id_sucursal'], $infoFac['id_usuario']);


$rowsConceptos = $fac->listarConceptos($id_factura);

if (!$res['timbre_cancelado']) {
	$mpdf = new mPDF('es-MX', 'Letter');

	$emisor_nombre = $infoFac['emisor'];
	$emisor_direccion = $infoEmisor['calle'] . " " . $infoEmisor['num_ext'] . " " . $infoEmisor['num_int'];
	$emisor_colonia = $infoEmisor['colonia'];
	$emisor_ciudad = $receptor_municipio;
	$emisor_codigo_postal = $infoEmisor['codigo_postal'];
	$emisor_rfc = $infoFac['rfc_emisor'];
	$emisor_regimen = $emisor['regimen_fiscal'];

	$receptor_nombre = $infoReceptor['nombre'];
	$receptor_direccion = $infoReceptor['calle'] . " " . $infoReceptor['num_ext'] . " " . $infoReceptor['num_int'];
	$receptor_colonia = $infoReceptor['colonia'];
	$receptor_ciudad = $infoReceptor['municipio'] . " " . $infoReceptor['estado'];
	$receptor_codigo_postal = $infoReceptor['codigo_postal'];
	$receptor_rfc = $infoReceptor['rfc'];
	$serie = $infoFac['serie'];
	$folio = $infoFac['folio'];
	$metodo_pago = $infoFac['metodo_pago'];
	$digitos_tarjeta = $infoFac['digitos_tarjeta'];
	$factura_subtotal = $infoFac['subtotal'];
	$factura_iva = $infoFac['iva'];
	$retencion_iva = $infoFac['retencion_iva'];
	$retencion_isr = $infoFac['retencion_isr'];
	$retencion_ieps = $infoFac['retencion_ieps'];
	$factura_tasa_iva = $infoFac['tasa_iva'];
	$factura_total = $infoFac['total'];

	$factura_fecha = '';
	$factura_localidad = $sucursal['municipio'] . " " . $sucursal['estado'];
	$forma_pago = '';
	$conceptos_html = '';
	$certificado_sat = '';
	$certificado_emisor = '';
	$fecha_timbrado = '';
	$uuid = '';
	$cadena_timbre = '';
	$sello_digital_emisor = '';
	$sello_digital_sat = '';
	$cbb = '';

	$total_letra = monedaATexto($factura_total);
	$plantilla = reset($oPtlla->plantillaComprobante($infoFac['id_usuario'], $infoFac['tipo_comprobante']));

	$oTpl->loadFromString($plantilla['html']);

	$oTpl->setVar(
			array(
				'EMISOR_NOMBRE' => $emisor_nombre,
				'EMISOR_DIRECCION' => $emisor_direccion,
				'EMISOR_COLONIA' => $emisor_colonia,
				'EMISOR_CIUDAD' => $emisor_ciudad,
				'EMISOR_CODIGO_POSTAL' => $emisor_codigo_postal,
				'EMISOR_TELEFONO' => $infoEmisor['telefonos'],
				'EMISOR_RFC' => $emisor_rfc,
				'EMISOR_REGIMEN' => $emisor_regimen,
				'RECEPTOR_RAZON_SOCIAL' => $receptor_nombre,
				'RECEPTOR_DIRECCION' => $receptor_direccion,
				'RECEPTOR_COLONIA' => $receptor_colonia,
				'RECEPTOR_CIUDAD' => $receptor_ciudad,
				'RECEPTOR_CODIGO_POSTAL' => $receptor_codigo_postal,
				'RECEPTOR_RFC' => $receptor_rfc,
				'FACTURA_FOLIO' => trim($serie . ' ' . $folio),
				'FACTURA_FECHA' => $factura_fecha,
				'FACTURA_LUGAR_EMISION' => $factura_localidad,
				'METODO_PAGO' => $metodo_pago,
				'FORMA_PAGO' => $forma_pago,
				'ULTIMOS_DIGITOS' => $digitos_tarjeta,
				'FACTURA_CONDICIONES' => '',
				'FACTURA_CONCEPTOS' => $conceptos_html,
				'FACTURA_SUBTOTAL' => pesos($factura_subtotal),
				'FACTURA_IVA' => pesos($factura_iva),
				'RETENCION_IVA' => pesos($retencion_iva),
				'RETENCION_ISR' => pesos($retencion_isr),
				'RETENCION_IEPS' => pesos($retencion_ieps),
				'TASA_IVA' => '10', //$factura_tasa_iva,
				'FACTURA_TOTAL' => ($factura_total),
				'CERTIFICADO_SAT' => $certificado_sat,
				'CERTIFICADO_EMISOR' => $certificado_emisor,
				'FECHA_CERTIFICADO' => $fecha_timbrado,
				'FOLIO_FISCAL' => $uuid,
				'CADENA_ORIGINAL' => $cadena_timbre,
				'SELLO_DIGITAL_EMISOR' => $sello_digital_emisor,
				'SELLO_DIGITAL_SAT' => $sello_digital_sat,
				'IMG_CCB' => $cbb,
				'TOTAL_LETRA' => $total_letra,
				'LOGOTIPO' => $logotipo,
				'LOGO_X' => $infoEmisor['pos_x'] . 'px',
				'LOGO_Y' => $infoEmisor['pos_y'] . 'px',
				'LOGO_W' => $infoEmisor['ancho'] . 'px',
				'LOGO_H' => $infoEmisor['alto'] . 'px',
				'EMISOR_X' => $infoEmisor['margen_datos_emisor'] . 'px',
				'IMAGENES_PLANTILLAS' => FS_IMAGENES_PLANTILLAS
			)
	);

	//-- Elimina block de logotipo si no se ha configurado la imagen
	$oTpl->removeBlock('LOGOTIPO', empty($logotipo));

	if ($oTpl->getBlock('DETALLE_CONCEPTOS')) {
		$sizeArray = count($rowsConceptos);
		for ($i = 0; $i < $sizeArray; $i++) {
			$descri = str_replace(chr(13) . chr(10), '<br>', $rowsConceptos[$i]['concepto']);
			$oTpl->setVar(
					array(
						'CANTIDAD' => $rowsConceptos[$i]['cantidad'],
						'UNIDAD_MEDIDA' => $rowsConceptos[$i]['unidad'],
						'DESCRIPCION_CONCEPTO' => $descri,
						'PRECIO_UNITARIO' => pesos($rowsConceptos[$i]['precio_unitario']),
						'IMPORTE_CONCEPTO' => pesos($rowsConceptos[$i]['importe'])
					)
			);
			$oTpl->appendBlock();
			
			// Se agrupan los valores de IVA.
			$arrayImpuestos = array();
			if(empty($arrayImpuestos['IVA'][$item['tasa_iva']]['tasa']) ){
				$arrayImpuestos['IVA'][$rowsConceptos['tasa_iva']]['importe'] = (string)$rowsConceptos[$i]['iva'];
				$arrayImpuestos['IVA'][$rowsConceptos['tasa_iva']]['tasa']	 = (string)$rowsConceptos[$i]['tasa_iva'];
			}else {
				$arrayImpuestos['IVA'][$rowsConceptos['tasa_iva']]['importe'] = (string)((float)$arrayImpuestos['IVA'][$item['tasa_iva']]['importe'] + (float)$rowsConceptos['iva']);
				$arrayImpuestos['IVA'][$rowsConceptos['tasa_iva']]['tasa'] = (string)$rowsConceptos['tasa_iva'];
			}

			if(empty($arrayImpuestos['IEPS'][$rowsConceptos['tasa_ieps']]['tasa'])){
				$arrayImpuestos['IEPS'][$rowsConceptos['tasa_ieps']]['importe'] = (string)$rowsConceptos['ieps'];
				$arrayImpuestos['IEPS'][$rowsConceptos['tasa_ieps']]['tasa']	 = (string)$rowsConceptos['tasa_ieps'];
			}else{
				$arrayImpuestos['IEPS'][$rowsConceptos['tasa_ieps']]['importe'] = (string)((float)$arrayImpuestos['IVA'][$rowsConceptos['tasa_ieps']]['importe'] + (float)$rowsConceptos['ieps']);
				$arrayImpuestos['IEPS'][$rowsConceptos['tasa_ieps']]['tasa'] = (string)$rowsConceptos['tasa_ieps'];
			}
			
		}
		$oTpl->putBlock('DETALLE_CONCEPTOS');
	}
	

	
//exit();
	//-- Validacion de Block para Retencion
	$oTpl->removeBlock('RETENCION_IVA_LABEL', $retencion_iva == 0);
	$oTpl->removeBlock('RETENCION_LEYENDA', $retencion_iva == 0);
	$oTpl->removeBlock('RETENCION_IVA_VALUE', $retencion_iva == 0);
	
	
	//-- Procesamiento de bloque de IVA's
	if ($oTpl->getBlock('DETALLE_IVAS_LABEL')) {
		foreach ($rowsConceptos as $k) {
			if ($k > 0) {
				$oTpl->setVar(array('TASAIVA' => pesos($k['tasa_iva'],2) ) );
				$oTpl->appendBlock();
			}
		}
		$oTpl->putBlock('DETALLE_IVAS_LABEL');
	}
	
	if ($oTpl->getBlock('DETALLE_IVAS_VALUE')) {
		foreach ($rowsConceptos as $k) {
//			var_dump(round($k['iva'],2));
			if ($k > 0) {
				$oTpl->setVar(array('IMPORTEIVA' => pesos($k['iva'],2) ) );
				$oTpl->appendBlock();
			}
		}
		$oTpl->putBlock('DETALLE_IVAS_VALUE');
	}
	
	
	//-- Extraemos plantilla procesada
	$strPDF = utf8_decode($oTpl->publish(true));

//	$css = file_get_contents(FS_LISTADO_FACTURAS . 'imprimir/recibo.css');
	$mpdf->WriteHTML($plantilla['css'], 1);
	$mpdf->WriteHTML($strPDF, 0);
	if (!file_exists(FS_TEMP))
		mkdir(FS_TEMP);

	$name = 'factura_' . trim($serie . $folio) . '.pdf';
	$mpdf->Output(FS_TEMP . $name, 'F');

	$oTpl->load(FS_LISTADO_FACTURAS . 'imprimir/invoiceView.html');
	$oTpl->setVar(array('DOCUMENT_SOURCE' => WS_FRAMEWORK . 'downloadPdf.php?pdf=' . $name));

	$result['timbrada'] = 1;
	$result['html'] = $oTpl->publish(true);
	$result['name_file'] = $name;
}else {
	$result['timbrada'] = 0;
}

if (isset($enviar)) {
	return json_encode($result);
} else {
//	unlink(FS_TEMP . "cbb" . $id_factura . ".jpg");
	echo json_encode($result);
}
?>