<?php

require_once('./nusoap/nusoap.php');
require_once (FS_CLASSES . 'genera_xml.php');
require_once(FS_CLASSES . 'FacturasDAO.php');
require_once(FS_CLASSES . 'FolioDAO.php');
require_once(FS_CLASSES . 'ConfWsdlDAO.php');
require_once(FS_CLASSES . 'PaqueteDAO.php');


$urlWsdl = new ConfWsdlDAO();
$timbradoWsdl = $urlWsdl->getConfigWsdl();

$client = new nusoap_client($timbradoWsdl['timbrado'], true);

$err = $client->getError();
if ($err) {
    die('<h2>Constructor error</h2><pre>' . $err . '</pre>');
}

$fac = new FacturasDAO();
$id_factura = $_POST['nId_factura'];
$status_fac = $fac->getStatus($id_factura);

if ($status_fac['cancelada'] == 0) {
    if ($status_fac['timbrada'] == 0) {

        //Se verifica que el usuario cuente con un paquete activo
        $info_paquete = new PaqueteDAO();
        $paquete_usuario = $info_paquete->getPaqueteCuenta($_SESSION['user']->id_usuario);
        if ($paquete_usuario['restantes'] > 0 && !empty($paquete_usuario['restantes']) && isset($paquete_usuario)) {

            //-- Recupera 
            $folio = $fac->getFolioFactura($id_factura);

            //-- Verifica si factura ya tiene folio y series asignados o es necesario asignar un nuevo folio
            if (intval($folio['folio']) <= 0) {
                //-- Asignacion de Serie y Folio para factura si aun no tiene folio
                $oFolio = new FolioDAO();
                $folio = $oFolio->asigaFolioComprobante($_SESSION['user']->id_usuario, $fac->getTipoComprobante($id_factura));
            }

            //-- Valida que se haya obtenido un folio y serie para la factura
            if ($folio != null) {
                //-- Actualizar la serie y folio para la factura
                $fac->updateFolioFactura($id_factura, $folio['serie'], $folio['folio']);


                //Se genera el archivo XML con la informacion de la factura.
                $obj = new genera_xml();
                $res = $obj->xmlFactura($id_factura);
                $xml = $res[0]['xml'];
                $rfc = $res[0]['rfc_emisor'];

                $factura = array(
                    'xml' => $xml,
                    'rfc' => $rfc
                );

                $result = $client->call('timbradoCFDi', array('in' => $factura));

                if ($client->fault) {
                    echo '<h2>Error Fault</h2>';
                } else {
                    $err = $client->getError();
                    if ($err) {
                        $result['result'] = 0;
                	$result['msg'] = 'Error;' . $err;

                    } else {
                        //Se guarda la informacion del timbrado.
                        if ($result['result'] == 0) {
                            $data['nId_factura'] = $id_factura;
                            $data['sUuid'] = $result['uuid'];
                            $data['tCadena_timbre'] = $result['cadena_timbre'];
                            $data['bQrcode'] = $result['qrcode'];
                            $data['tXml'] = $result['xml'];
                            $data['dFecha_timbrado'] = $result['fecha_timbrado'];
                            $data['sNomina'] = 0;

                            $fac->insTimbrado($data);
                            //Se actualiza la cantidad de timbres disponibles para el usuario.
                            $info_paquete->updPaqueteCuenta($_SESSION['user']->id_usuario);
                        }
                        $result['msg'] = $result['message'];
                    }
                }
            } else {
                $result['result'] = 1;
                $result['msg'] = "No se ha configurado la serie y folio para este tipo de comprobante.";
            }
        } else {
            $result['result'] = 1;
            $result['msg'] = "No cuenta con un paquete de timbres disponible.";
        }
    } else {
        $result['result'] = 1;
        $result['msg'] = "Este comprobante ha sido timbrado previamente.";
    }
} else {
    $result['result'] = 1;
    $result['msg'] = "Este comprobante ha sido cancelado.";
}

//var_dump($result);

echo json_encode_utf8($result);
?>