<?php
require_once FS_CLASSES . 'Cliente.php';
/**
 * @author Angel
 * @version 1.0
 * @created 20-ago-2013 02:56:54 p.m.
 */
class ClienteDAO extends Cliente {

	/**
	 * Lista todos los clientes
	 */
	public function listarClientesCuenta() {
		return $this->executeSP("stp_listarClientes(:id)", array('id' => $_SESSION['user']->id_usuario));
	}
	
	public function listarClientes() {
		return $this->executeSP("stp_Clientes(:id)", array('id' => $_SESSION['user']->id_usuario));
	}
	
	public function buildCombo( $id = null ){
		$rows = $this->listarClientes();
		
		if(!is_int($id) && $id != NULL){
			$values['sNombre'] = $id;
			$values['nId_usuario'] = $_SESSION['user']->id_usuario;
			$id_cliente = $this->executeSP("stp_getIdCliente(:sNombre, :nId_usuario)", $values);
			$id = $id_cliente[0]['id_cliente'];
		}
		
		$options = listForCombo($rows, "id_cliente", "nombre", $id);
		return $options;
	}
	
	
	
	/**
	 * Valida los datos
	 */
	public function validateData( $data ) {
		
	}

	/**
	 * Busca un cliente en especifico
	 * @param $id id del cliente a buscar
	 */
	public function buscarCliente( $id ) {
		$values['id_cliente'] = $id;
		return $this->executeSP("stp_buscaCliente(:id_cliente)", $values);
	}

	/**
	 * Inserta un cliente
	 * @param $data datos del cliente a insertar
	 */
	public function insCliente( $values ) {
		return $this->updCliente($values);
	}

	/**
	 * Actualiza un cliente en especifico
	 * @param $data datos del cliente a actualizar
	 */
	public function updCliente( $values ) {
		$sp = "stp_updCliente(
			:id_cliente,
			:id_usuario,
			:nombre,
			:rfc,
			:calle,
			:num_ext,
			:num_int,
			:colonia,
			:codigo_postal,
			:id_estado,
			:id_municipio,
			:telefonos,
			:e_mail,
			:activo
		)";
		
		return $this->executeSP($sp, $values);
	}

	/**
	 * Cambia el estatus de un registro de cliente
	 * @param id id del cliente cuyo estatus cambiara
	 */
	public function statusCliente($values) {
		$sp = "stp_statusCliente(:id_cliente, :activo)";
		return $this->executeSP($sp, $values);
	}
	
	public function recuperarCliente($id_cliente){
		$sp = "stp_recuperarInfoCliente(:id_cliente)";
		return array_shift($this->executeSP($sp, array('id_cliente' => $id_cliente)));
	}
	
	public function infoClienteByIdFactura($id_factura){
		$sp = "stp_InfoClienteByIdFactura(:id_factura)";
		return array_shift($this->executeSP($sp, array('id_factura' => $id_factura)));
	}
	
	
	/**
	 * Inserta el listado de empleados del cliente
	 * @param $data informacion del empleado
	 */
	public function insEmpleado( $values ) {
		$sp = "stp_agregaEmpleados(:nId_usuario,
							:nId_empleado,
							:sNombre,
							:sEmail,
							:sRfc,
							:sCurp,
							:nNss,
							:nTipoRegimen,
							:dFechaContrato,
							:fSalarioBase,
							:fSalarioDiario,
							:sPuesto,
							:sTipoContrato,
							:sTipoJornada,
							:nRiesgoPuesto)";
		return $this->executeSP($sp, $values);
	}
	
	/**
	 * Inserta el listado de empleados del cliente
	 * @param $data informacion del empleado
	 */
	public function listaEmpleados() {
		$sp = "stp_listaEmpleados(:nId_usuario)";
		return $this->executeSP($sp, array('nId_usuario' => $_SESSION['user']->id_usuario));
	}
	
	
	
	/**
	 * Inserta el listado de empleados del cliente
	 * @param $data informacion del empleado
	 */
	public function insNomina( $values ) {
		$sp = "stp_agregaNomina(:nId_usuario,
							:nId_empleado,
							:dFechaPago, 
							:dFechaIniPago, 
							:dFechaFinPago, 
							:nNumDiasPago, 
							:sPeriodicidadPago,
							:fTotalGravadoP, 
							:fTotalExentoP, 
							:nTipoPercepcion, 
							:sClaveP, 
							:sConceptoP, 
							:fImporteGravadoP, 
							:fImporteExentoP,
							:fTotalGravadoD, 
							:fTotalExentoD, 
							:nTipoDeduccion, 
							:sClaveD, 
							:sConceptoD, 
							:fImporteGravadoD, 
							:fImporteExentoD,
							:fDiasIncapacidad, 
							:nTipoIncapacidad, 
							:sDescuento,
							:nDias, 
							:sTipoHoras, 
							:nHorasExtra, 
							:fImportePagado
)";
		return $this->executeSP($sp, $values);
	}
}

?>