<?php

require_once ('Facturas.php');

/**
 * @author Angel
 * @version 1.0
 * @created 20-ago-2013 02:57:18 p.m.
 */
class FacturasDAO extends Facturas {

	/**
	 * Devuelve todos los registros de Facturas o solo el especificado por el id
	 * @param $data Valor entero para regresar un registro especifico. Si se omite, regresa todos los registros
	 * @return array
	 */
	public function listarFactura($data = NULL) {
		return $this->executeSP("stp_Facturas(:nId_factura)", array('nId_factura' => $data));
	}
	
	/**
	 * Devuelve todos los registros de Facturas o solo el especificado por el id
	 * @param $data Valor entero para regresar un registro especifico. Si se omite, regresa todos los registros
	 * @return array
	 */
	public function listarFacturas($data = NULL) {
		return $this->executeSP("stp_listarFacturas(:id_usuario)", array('id_usuario' => $_SESSION['user']->id_usuario));
	}
	
	/**
	 * Registra el nuevo comprobante
	 * @param $data Array que contiene la informacion a registrar
	 * @return array
	 */
	public function insFacturas($data) {
		$sp = "stp_insFacturas(:nId_usuario,
								:nId_factura,
								:nTipo_comprobante,
								:nTipo_formato,
								:nId_receptor,
								:nSucursal_Emisora,
								:nDigitos_tarjeta,
								:fIva_total,
								:fTasa_iva,
								:fRetencion_iva,
								:fRetencion_isr,
								:fRetencion_ieps,
								:fIeps_total,
								:sMetodo_pago,
								:sForma_pago,
								:fSubtotal,
								:fTotal,
								:sLista_conceptos,
								:sObservaciones)";
		return array_shift($this->executeSP($sp, $data));		
	}
	
	
	public function listarConceptos($data = NULL) {
		return $this->executeSP("stp_ListaConceptos(:nId_factura)", array('nId_factura' => $data));
	}
	
	/**
	 * Copia un registro de facturas
	 * @param $data Array que contiene la informacion a copiar
	 * @return array
	 */
	public function copiarFactura($data) {
		$sp = "stp_copiarFacturas(:nId_factura)";
		return array_shift($this->executeSP($sp, array('nId_factura' => $data)));		
	}
	
	
	public function obtenerInformacionFactura($data = NULL) {
		return array_shift($this->executeSP("stp_InfoFacturas(:nId_factura)", array('nId_factura' => $data)));
	}
	
	/**
	 * Registra el timbrado de la factura.
	 * @param $data Array que contiene la informacion a registrar
	 * @return array
	 */
	public function insTimbrado($data) {
		$sp = "stp_insTimbrado(:nId_factura,
								:sUuid,
								:tCadena_timbre,
								:bQrcode,
								:tXml,
								:dFecha_timbrado, :sNomina)";
		return array_shift($this->executeSP($sp, $data));
	}
	
	public function getStatus($id_factura){
		$sp = "stp_getStatusFactura(:nId_factura)";
		return array_shift($this->executeSP($sp, array('nId_factura' => $id_factura)));
	}
	
	public function cancelarFactura($id_factura) {
		$sp = "stp_cancelarFactura(:nId_factura)";
		return array_shift($this->executeSP($sp, array('nId_factura' => $id_factura)));
	}
	
	public function obtenerInfoTimbrado($id_factura) {
		$sp = "stp_obtenerInfoTimbrado(:nId_factura)";
		return array_shift($this->executeSP($sp, array('nId_factura' => $id_factura)));
	}
	
	public function insNotaFactura($data){
		$sp = "stp_insNotaFactura(	:nId_factura,
									:sDescripcion)";
		return array_shift($this->executeSP($sp, $data));
	}
	
	public function getNotaFactura($id_factura){
		$sp = "stp_getNotaFactura(	:nId_factura)";
		return $this->executeSP($sp, array('nId_factura' => $id_factura));
	}
	
	
	public function get_infoImprimirFactura($id_factura){
		$sp = "stp_getInfoImprimirFactura(:nId_factura)";
		return array_shift($this->executeSP($sp, array('nId_factura'=> $id_factura)));
	}
	
	
	public function getFolioFactura($id_factura){
		$sp = "stp_getFolioFactura(:id_factura)";
		return reset($this->executeSP($sp, array('id_factura'=> $id_factura)));
	}
	
	public function updateFolioFactura($id_factura, $serie, $folio) {
		$values = array(
			'id_factura'=> $id_factura,
			'serie'=> $serie,
			'folio'=> $folio
		);
		
		$sp = "stp_updFolioFactura(:id_factura,:serie,:folio)";
		$this->executeSP($sp, $values);
	}
	
	public function getTipoComprobante($id_comprobante){
		$sp = "stp_getTipoComprobante(:nId_comprobante)";
		return array_shift(reset($this->executeSP($sp, array('nId_comprobante'=> $id_comprobante))));
	}
	
	public function tourInvoicing(){
		return $this->executeSP("stp_tourInvoicing(:id_usuario)", array('id_usuario' => $_SESSION['user']->id_usuario));
	}
}

?>