<?php
require_once ('FormaPago.php');

/**
 * @author Angel
 * @version 1.0
 * @created 05-ago-2013 05:13:05 p.m.
 */
class FormaPagoDAO extends FormaPago
{

	/**
	 * Devuelve todos los registros de formas de pago o solo el especificado por el id
	 * @param $data Valor entero para regresar un registro especifico. Si se omite, regresa todos los registros
	 * @return array
	 */
	public function ListarFormaPago($data = NULL){
		return $this->executeSP("stp_FormaPago(:id)", array('id' => $data));
	}
	public function buildCombo( $idForma = NULL){
		if(!is_int($idForma) && $idForma != NULL){
			$rows = $this->ListarFormaPago();
			$idForma = $this->executeSP("stp_getIdFormaPago(:sNombre)", array('sNombre' => $idForma));
			if(empty($idForma[0]['id_forma_pago'])){
				$id = 0;
			}else{
				$id = $idForma[0]['id_forma_pago'];
			}
		}else{
			$rows = $this->ListarFormaPago($idForma);
			$id = NULL;
		}
		
		$options = listForCombo($rows, "id_forma_pago", "descripcion", $id);
		return $options;
	}

	/**
	 * Funcion que valida la informacion
	 * @param $data Array con la informacion capturada
	 * @return array
	 */
	public function validateData($data){
		$data = (object) $data;
		$result = false;
		$errors = '';
		$ids = '';

		if (empty($data->descripcion)) {
			$errors .= "- Descripcion no puede estar en blanco.\n";
			$ids .= ',#descripcion';
		} else {
			$forma = array_shift($this->executeSP('stp_validaFormaPago(:descripcion)', array('descripcion' => $data->descripcion)));
			if (! empty($forma['id_forma_pago']) && $forma['id_forma_pago'] != $data->id_forma) {
				$errors .= "- Descripcion ya se encuentra registrada.\n";
				$ids .= ',#descripcion';
			}
		}

		$result['ok'] = empty($errors);
		$result['error']['ids'] = preg_replace('/^,(.*)/','$1',$ids);
		$result['error']['msg'] = $errors;

		return array_utf8Decode($result);
	}

	/**
	 * Registra una nueva forma de pago
	 * @param $data Array que contiene la informacion a registrar
	 * @return array
	 */
	public function insertFormaPago($data){
		return array_shift($this->executeSP("stp_insFormaPago(:descripcion, :activo)", $data));
	}

	/**
	 * Actualiza la forma de pago especificada
	 * @param $data Array que contiene la informacion y Id del registro a actualizar
	 * @return array
	 */
	public function updateFormaPago($data){
		return array_shift($this->executeSP("stp_updFormaPago(:id_forma, :descripcion, :activo)", $data));
	}

/**
	 * Cambia el estatus de activo del registro especificado
	 * @param $id_unidad_medida Valor entero, Id del registro
	 * @return array
	 */
	public function statusFormaPago($id_forma_pago){
		return $this->executeSP("stp_statusFormaPago(:id_forma)", array('id_forma' => $id_forma_pago));
	}

}
?>