<?php

require_once ('ModalidadPago.php');

/**
 * @author Angel
 * @version 1.0
 * @created 05-ago-2013 05:13:15 p.m.
 */
class ModalidadPagoDAO extends ModalidadPago {

	public $m_ModalidadPago;

	/**
	 * Devuelve todos los registros de modalidades de pago o solo el especificado por el id
	 * @param $data Valor entero para regresar un registro especifico. Si se omite, regresa todos los registros
	 * @return array
	 */
	public function listaModalidadPago($data = NULL) {
		return $this->executeSP("stp_ModalidadPago(:id)", array('id' => $data));
	}

	public function buildCombo($id_modalidad = NULL){
		if(!is_int($id_modalidad) && $id_modalidad != NULL){
			$rows = $this->listaModalidadPago();
			$id_modalidad = array_shift($this->executeSP("stp_getIdModalidadPago(:sNombre)", array('sNombre' => $id_modalidad)));
			$id = $id_modalidad['id_modalidad_pago'];
		}else{
			$rows = $this->listaModalidadPago($id_modalidad);
			$id = NULL;
		}
		$rows = $this->listaModalidadPago();
		$options = listForCombo($rows, "id_modalidad_pago", "descripcion", $id);
		return $options;
	}

	/**
	 * Funcion que valida la informacion
	 * @param $data Array con la informacion capturada
	 * @return array
	 */
	public function validateData($data) {
		$data = (object) $data;
		$result = false;
		$errors = '';
		$ids = '';

		if (empty($data->descripcion)) {
			$errors .= "- Descripcion no puede estar en blanco.\n";
			$ids .= ',#descripcion';
		} else {
			$modalidad = array_shift($this->executeSP('stp_validaModalidadPago(:descripcion)', array('descripcion' => $data->descripcion)));
			if (!empty($modalidad['id_modalidad_pago']) && $modalidad['id_modalidad_pago'] != $data->id_modalidad) {
				$errors .= "- Descripcion ya se encuentra registrada.\n";
				$ids .= ',#descripcion';
			}
		}

		$result['ok'] = empty($errors);
		$result['error']['ids'] = preg_replace('/^,(.*)/', '$1', $ids);
		$result['error']['msg'] = $errors;

		return array_utf8Decode($result);
	}

	/**
	 * 
	 * @param data
	 */
	public function buscarModalidadPago($data) {
		
	}

	/**
	 * Registra una nueva modalidad de pago
	 * @param $data Array que contiene la informacion a registrar
	 * @return array
	 */
	public function insertModalidadPago($data) {
		$valida = array_shift($this->executeSP("stp_insModalidadPago(:descripcion, :activo)", $data));
		return $valida;
	}

	/**
	 * Actualiza la modalidad de pago especificada
	 * @param $data Array que contiene la informacion y Id del registro a actualizar
	 * @return array
	 */
	public function updateModalidadPago($data) {
		$valida = array_shift($this->executeSP("stp_updModalidadPago(:id_modalidad, :descripcion, :activo)", $data));
		return $valida;
	}

	/**
	 * Cambia el estatus de activo del registro especificado
	 * @param $id_unidad_medida Valor entero, Id del registro
	 * @return array
	 */
	public function statusModalidadPago($id_modalidad_pago) {
		return $this->executeSP("stp_statusModalidadPago(:id)", array('id' => $id_modalidad_pago));
	}

}

?>