<?php

require_once ('Nomina.php');

/**
 * @author Mario Cruz
 * @version 1.0
 * @created 20-ago-2013 02:57:18 p.m.
 */
class NominaDAO extends Nomina {

	/**
	 * Inserta el listado de nomina del cliente
	 * @param $data informacion de la nomina
	 */
	public function listaNomina($fecha, $pendientes = 0) {
		$sp = "stp_listaNomina(:nId_usuario, :dFecha, :nPendiente)";
		return $this->executeSP($sp, array('nId_usuario' => $_SESSION['user']->id_usuario, 'dFecha' => $fecha, 'nPendiente' => $pendientes));
	}
	
	public function getFolioNomina($id_nomina){
		$sp = "stp_getFolioNomina(:id_nomina)";
		return reset($this->executeSP($sp, array('id_nomina'=> $id_nomina)));
	}
	
	public function updateFolioNomina($id_nomina, $serie, $folio) {
		$values = array(
			'id_nomina'=> $id_nomina,
			'serie'=> $serie,
			'folio'=> $folio
		);
		
		$sp = "stp_updFolioNomina(:id_nomina,:serie,:folio)";
		$this->executeSP($sp, $values);
	}
	
	public function obtenerInformacionNomina($data = NULL) {
		return array_shift($this->executeSP("stp_InfoNomina(:nId_nomina)", array('nId_nomina' => $data)));
	}
	
	public function recuperarEmpleado($id_empleado){
		$sp = "stp_recuperarInfoEmpleado(:id_empleado)";
		return array_shift($this->executeSP($sp, array('id_empleado' => $id_empleado)));
	}
	
	public function listPercepciones($id_nomina){
		$sp = "stp_listaPercepciones(:id_nomina)";
		return ($this->executeSP($sp, array('id_nomina' => $id_nomina)));
	}
	
	public function listDeducciones($id_nomina){
		$sp = "stp_listaDeducciones(:id_nomina)";
		return ($this->executeSP($sp, array('id_nomina' => $id_nomina)));
	}
	
	public function obtenerConfigUsuario(){
		$sp = "stp_recuperaConfigUsuario(:nId_usuario)";
		return array_shift($this->executeSP($sp, array('nId_usuario' => $_SESSION['user']->id_usuario)));
	}
	
	/**
	 * Registra el timbrado de la nomina.
	 * @param $data Array que contiene la informacion a registrar
	 * @return array
	 */
	public function insTimbrado($data) {
		$sp = "stp_insTimbrado(:nId_factura,
								:sUuid,
								:tCadena_timbre,
								:bQrcode,
								:tXml,
								:dFecha_timbrado, 
								:sNomina)";
		return array_shift($this->executeSP($sp, $data));
	}
	
	public function obtenerInfoTimbrado($id_factura) {
		$sp = "stp_timbradoNomina(:nId_factura)";
		return array_shift($this->executeSP($sp, array('nId_factura' => $id_factura)));
	}
	
	public function obtenerMailEmpleado($id_nomina, $date = NULL) {
		$sp = "stp_getMailEmpleado(:nId_nomina, :dFecha_corte)";
		return $this->executeSP($sp, array('nId_nomina' => $id_nomina, 'dFecha_corte' => $date));
	}
	
	public function comprobanteNominaBatch($date = NULL) {
		$sp = "stp_getListaNominaBatch(:nId_usuario, :dFecha_corte)";
		return $this->executeSP($sp, array('nId_usuario' => $_SESSION['user']->id_usuario, 'dFecha_corte' => $date));
	}
	
	
}

?>