<?php

/**
 * Clase DAO para el manejo de los paquetes de timbrados
 * @author Carlos Almaguer <calmaguer@softnet.com.mx>
 */
require FS_CLASSES . "Paquete.php";

class PaqueteDAO extends Paquete {

	/**
	 * Obtiene un arreglo con la lista de los paquetes con estatus activo
	 * @return array
	 */
	public function paquetesActivos() {
		$_sql = "stp_paquetesActivos()";

		return $this->executeSP($_sql);
	}
	
	public function buscarPaquete($id_paquete = NULL) {
		
		$sql = "stp_buscarPaquete(:id)";
		$rs = reset($this->executeSP($sql, array('id' => $id_paquete)));
		return $rs;
	}
	
	public function listarPaquetesCuenta($id_usuario) {
		$sql = "stp_paquetesCuenta(:id)";
		$rs = $this->executeSP($sql, array('id' => $id_usuario));
		return $rs;
	}
	
	public function insertPaqueteCuenta($data) {
		$_paquete = $this->buscarPaquete($data['id_paquete']);
		$data += $_paquete;
		
		$_sql = "
			stp_insPaqueteCuenta(
				:id_usuario,
				:id_paquete,
				:cantidad,
				:vigencia_periodo,
				:vigencia_duracion
			)
		";
		
		$this->executeSP($_sql, $data);
	}
	
	public function deletePaqueteCuenta($data) {
		$_sql = "stp_delPaqueteCuenta(:id_usuario_paquete)";
		$this->executeSP($_sql, $data);
	}
	
	public function getPaqueteCuenta($id_usuario){
		$sql = "stp_vigenciaPaquete(:id_usuario)";
		return array_shift($this->executeSP($sql, array( 'id_usuario' => $id_usuario )));
	}
	
	public function updPaqueteCuenta($id_usuario){
		$sql = "stp_updPaqueteCuenta(:id_usuario)";
		return $this->executeSP($sql, array( 'id_usuario' => $id_usuario ));
	}
	
	public function consumoTimbres() {
		$sql = "stp_consumoTimbresUsuarios()";
		return $this->executeSP($sql);
	}
}

?>