<?php
require_once 'ProductoServicio.php';
/**
 * @author Angel
 * @version 1.0
 * @created 20-ago-2013 02:57:06 p.m.
 */
class ProductoServicioDAO extends ProductoServicio
{

	/**
	 * 
	 * @param data
	 */
	public function listarProductosServiciosFiltro($string)
	{
		return $this->executeSP("stp_ProductosServiciosFiltro(:id, :string)", array('id' => $_SESSION['user']->id_usuario, 'string' => $string));
	}
	
	public function listarProductosServicios($id_producto_servicio = NULL){
		return $this->executeSP("stp_ProductosServicios(:id_producto_servicio)", array('id_producto_servicio' => $id_producto_servicio));
	}
	
	public function listarProductos()
	{
		return $this->executeSP("stp_listarProductos(:id)", array('id' => $_SESSION['user']->id_usuario));
	}
	
	public function listarProductosActivos()
	{
		return $this->executeSP("stp_listarProductosActivos(:id)", array('id' => $_SESSION['user']->id_usuario));
	}
	
	public function buildCombo( $idProducto = NULL){
		
		$rows = $this->listarProductosActivos();
		$options = listForCombo($rows, "id_producto_servicio", "descripcion", $idProducto);
		return $options;
	}
	
	/**
	 * 
	 * @param data
	 */
	public function validateData( $values )
	{
		return $values;
	}

	/**
	 * 
	 * @param data
	 */
	public function buscarProductoServicio( $id )
	{
		$values['id'] = $id;
		return $this->executeSP("stp_buscarProductoServicio(:id)", $values);
	}

	/**
	 * 
	 * @param data
	 */
	public function insProductoServicio( $values )
	{
		return $this->executeSP(
				"stp_insProductoServicio(
					:id_usuario,
					:clave,
					:nombre,
					:descripcion,
					:id_unidad_medida,
					:precio_unitario,
					:activo,
					:con_impuestos,
					:tasa_iva,
					:tasa_ieps,
					:retencion_iva,
					:retencion_isr,
					:retencion_ieps
				)"
				, $values);
	}

	/**
	 * 
	 * @param data
	 */
	public function updProductoServicio( $values )
	{
		return $this->executeSP(
				"stp_updProductoServicio(
					:id_producto_servicio,
					:id_usuario,
					:clave,
					:nombre,
					:descripcion,
					:id_unidad_medida,
					:precio_unitario,
					:activo,
					:con_impuestos,
					:tasa_iva,
					:tasa_ieps,
					:retencion_iva,
					:retencion_isr,
					:retencion_ieps
				)"
				, $values);
	}

	/**
	 * 
	 * @param id_sucursal
	 */
	public function statusProductoServicio( $values )
	{
		return $this->executeSP(
				"stp_statusProductoServicio(
					:id,
					:activo
				)"
				, $values);
	}

}
?>