<?php

class DBConnector {

	private $dbServer;
	private $dbPort;
	private $dbUser;
	private $dbPassword;
	private $dbName;
	private $dbLink;

	public function get_dbLink() {
		return $this->dbLink;
	}

	public function set_dbLink($oDB = true) {
		if (!is_object($oDB)) {
			if (is_bool($oDB)) {
				$_db_config = file_get_contents(FS_CONFIG . 'db.config');
				$_db = unserialize(base64_decode(str_rot13($_db_config)));
//                                                               print_r($_db);

				$this->dbServer = $_db->DB_HOST;
				$this->dbPort = $_db->DB_PORT;
				$this->dbUser = $_db->DB_USERNAME;
				$this->dbPassword = $_db->DB_PASSWORD;
				$this->dbName = $_db->DB_DATABASE;
			}

			$dsn = 'mysql:host=' . $this->dbServer . ';'
					. 'port=' . $this->dbPort . ';'
					. 'dbname=' . $this->dbName;

			try {
				@$this->dbLink = new PDO($dsn, $this->dbUser, $this->dbPassword, array(PDO::MYSQL_ATTR_USE_BUFFERED_QUERY => 1));
//				$this->dbLink->setAttribute(PDO::MYSQL_ATTR_USE_BUFFERED_QUERY, true);
//				$this->dbLink->setAttribute(PDO::MYSQL_ATTR_USE_BUFFERED_QUERY, 1);
			} catch (PDOException $e) {
				printf("Connect failed: %s\n", $e->getMessage());
				exit();
			}
		} else {
			$this->dbLink = $oDB->get_dbLink();
		}
	}

	public function __construct($_xxx = null, $server = '', $port = '', $user = '', $password = '', $database = '') {
		if (strlen($server) > 0)
			$this->dbServer = $server;
		if (strlen($port) > 0)
			$this->dbPort = $port;
		if (strlen($user) > 0)
			$this->dbUser = $user;
		if (strlen($password) > 0)
			$this->dbPassword = $password;
		if (strlen($database) > 0)
			$this->dbName = $database;

//                             if (! $this->dbLink) {
//		}

//		if (is_null($_xxx) || !is_object($_xxx)) {
//			$this->set_dbLink();
//		} else {
//			$this->set_dbLink($_xxx);
//		}
	}

	function query($sql, $values = array()) {
		$_result = false;
		
		$this->set_dbLink();
		
		if (($_stmt = $this->dbLink->prepare($sql))) {
			if (preg_match_all('/(:\w+)/', $sql, $_named, PREG_PATTERN_ORDER)) {
				$_named = array_pop($_named);

				foreach ($_named as $_param) {
					$_stmt->bindValue($_param, $values[substr($_param, 1)]);
				}
			}

			try {
//				echo "execute," .$sql;
				if (!$_stmt->execute()) {
					echo $sql . "\n";
					print_r($_stmt->errorInfo());
				}
//				echo "done<br>";
//                $i = 0;
				do {
//					echo "Result Set No. " . (++$i) . " \n";
					$_result[] = $_stmt->fetchAll(PDO::FETCH_ASSOC);
				} while ($_stmt->nextRowset());
				
//				$_result = $_stmt->fetchAll(PDO::FETCH_ASSOC);
				$_stmt->closeCursor();
				$_result = reset($_result);
				$_stmt = null;
				
				$this->dbLink = null;
			} catch (PDOException $e) {
				echo "Excepcion atrapada";
				print_r($e->getMessage());
			}
		}

		return $_result;
	}

	public function executeSP($spName, $values = array()) {
		$_rs = $this->query('CALL ' . $spName, $values);

		return $_rs;
	}
	
	public function getLastInsertId( $field ) {
		$rs = reset($this->query( 'SELECT LAST_INSERT_ID() AS ' . $field ));

		return $rs[$field];
	}
	
	/**
	 * Metodo que establece las propiedades del objeto
	 * @param array $data Contiene la consulta a la BD
	 */
	public function setProperties($data)
	{
		foreach ($data as $key => $value) {
			$method = SETTER_PREFIX . $key;

			if (method_exists($this, $method)) {
					$this->$method($value);
			} else {
					die('Método ' . $method . ' no esta definido en la clase.');
			}
		}
	}
	
	/**
	 * Metodo para obtener la lista de valores definidos para un campo de tipo enum
	 * @param type $table_name
	 * @param type $column_name
	 */
	public function getEnumValues($table_name, $column_name)
	{
		$_sql = "SHOW COLUMNS FROM $table_name WHERE FIELD = '$column_name'";
		$_result = reset($this->query($_sql));
		preg_match_all('/\'([^\']+)\'/', $type = $_result['Type'], $matches, PREG_PATTERN_ORDER);
		
		return ($matches[1]);
	}
}

?>
