<?php

class Template
{
	private $_template;
	private $_block;
	private $_tempBlock;
	
	private function _pushTemplate($template)
	{
		$this->_template[] = $template;
	}
	
	private function _getTemplate()
	{
		return end($this->_template);
	}
	
	private function _setTemplate($str)
	{
		$this->_template[count($this->_template) - 1] = $str;
	}
	
	private function _pushBlock($block)
	{
		$this->_pushTemplate($block);
		$this->_tempBlock[] = $block;
		$this->_block[] = '';
	}
	
	private function _popBlock()
	{
		array_pop($this->_template);
		array_pop($this->_block);
		array_pop($this->_tempBlock);

		return $this->_getTemplate();
	}
	
	private function _getBlock()
	{
		return end($this->_block);
	}

	private function _setBlock($str)
	{
		$this->_block[count($this->_block) - 1] = $str;
	}
	
	private function _restoreBlock()
	{
		$this->_setTemplate(end($this->_tempBlock));
	}
	
	private function _setHtmlHeadIncludes(&$data)
	{
		preg_match('/<HEAD:LINKS +include="(.*)"\/>/', $data, $head);
		$mods = $head[1];
		$links = '';
		
		if (file_exists(FS_CSS . 'img/favicon.ico')) {
			$links = '<link rel="shortcut icon" href="<VAR:WSCSS/>img/favicon.ico"/>' . CR . LF . TAB;
		}
		
		//-- Links base (CSS base del Framework y JQuery)
		$links .= '<link href="<VAR:WSFRAMEWORK/>css/basic.css" rel="stylesheet" type="text/css"/>' . CR . LF . TAB
			. '<link href="<VAR:WSFRAMEWORK/>css/validator.css" rel="stylesheet" type="text/css"/>' . CR . LF . TAB
			. '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>js/jquery/jquery-1.8.2.min.js"></script>' . CR . LF . TAB
. '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>js/jquery/jquery.form.js"></script>' . CR . LF . TAB
			. '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>js/common_functions.js?_=' . time() . '" charset="utf-8"></script>' . CR . LF . TAB
			. '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>js/moment.min.js" charset="utf-8"></script>' . CR . LF . TAB;
		
		//-- Incluir JqueryUI 1.8.24 - Tema default = lightness
		$links .= '<link type="text/css" href="<VAR:WSFRAMEWORK/>js/jquery/css/<VAR:UI_THEME/>/jquery-ui-1.9.0.custom.min.css" rel="stylesheet" /> ' . CR . LF . TAB
			. '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>js/jquery/jquery-ui-1.9.0.custom.min.js"> </script>' . CR . LF . TAB;		
//			. '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>js/jquery/jquery.ui.datepicker.js"> </script>' . CR . LF . TAB;

//		//-- Incluir modificacion al JQuery UI para tabs verticales.
//		if (strpos($mods, 'UI_VERTICAL_TABS') !== false) {
//		$links .= '<link type="text/css" href="<VAR:WSROOT/>css/verticalTabs.css" rel="stylesheet" />' . CR . LF . TAB
//			. '<script type="text/javascript" src="<VAR:WSROOT/>js/verticalTabs.js"> </script>' . CR . LF . TAB;
//		}
		
		//-- Incluir CSS base para la aplicacion
		if (file_exists(FS_CSS . 'app.css')) {
			$links .= '<link href="<VAR:WSCSS/>app.css" rel="stylesheet" type="text/css" />' . CR . LF . TAB;
		}

		//-- Incluir CSS para grids de la aplicacion
		if (file_exists(FS_CSS	. 'grid.css')) {
			$links .= '<link rel="stylesheet" type="text/css" href="<VAR:WSCSS/>grid.css" />' . CR . LF . TAB;
		}
		
		//-- Incluir modulo de ValidacionJS
		if (strpos($mods, 'VALIDATORS') !== false) {
		$links .= '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>js/validatorScript.js?_=' . time() . '" charset="utf-8"></script>' . CR . LF . TAB;
		}
		
		//-- Incluir modulo de Tabs
		if (strpos($mods, 'TABS') !== false) {
		$links .= '<link href="<VAR:WSFRAMEWORK/>css/tabs.css" rel="stylesheet" type="text/css"/>' . CR . LF . TAB
			. '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>js/tabs.js?_=' . time() . '" charset="utf-8"></script>' . CR . LF . TAB;
		}
		
		//-- Incluir modulo de Carga dinamica de combos
		if (strpos($mods, 'COMBODYNAMIC') !== false) {
		$links .= '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>js/comboDynamic.js" charset="utf-8"></script>' . CR . LF . TAB;
		}
		
		//-- Incluir CSS para ventanas con dialog de Jquery UI
		if (strpos($mods, 'DIALOGS_JQ_UI') !== false) {
			$links .= '<link rel="STYLESHEET" type="text/css" href="<VAR:WSFRAMEWORK/>js/jquery/css/ui/jquery-ui.css"/>' . CR . LF . TAB.
			$links .= '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>js/jquery/ui/jquery-ui-1.10.3.js"></script>' . CR . LF . TAB;
			$links .= '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>js/adviceAndDialogs/dialogs.js"></script>' . CR . LF . TAB;
			$links .= '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>js/adviceAndDialogs/simpleAdvice.js"></script>' . CR . LF . TAB;
		}
		//-- Incluir modulos de DHMTLX
		if (strpos($mods, 'DHTMLX') !== false) {
			$links .= '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>dhtmlx/dhtmlxcommon.js"></script>' . CR . LF . TAB;
		}
		
		//-- Incluir modulos de DHMTLX CALENDAR
		if (strpos($mods, 'DHTMLX_CALENDAR') !== false) {
			$links .= 
			'<link rel="STYLESHEET" type="text/css" href="<VAR:WSFRAMEWORK/>dhtmlx/grid/dhtmlxgrid.css">' . CR . LF . TAB.
			'<link rel="stylesheet" type="text/css" href="<VAR:WSFRAMEWORK/>dhtmlx/grid/skins/dhtmlxgrid_dhx_skyblue.css">' . CR . LF . TAB.
			'<link rel="STYLESHEET" type="text/css" href="<VAR:WSFRAMEWORK/>dhtmlx/dhtmlxCalendar/codebase/dhtmlxcalendar.css">' . CR . LF . TAB.
			'<script  src="<VAR:WSFRAMEWORK/>dhtmlx/dhtmlxcommon.js"></script>' . CR . LF . TAB.
			'<script  src="<VAR:WSFRAMEWORK/>dhtmlx/grid/dhtmlxgrid.js"></script>' . CR . LF . TAB.
			'<script  src="<VAR:WSFRAMEWORK/>dhtmlx/grid/dhtmlxgridcell.js"></script>' . CR . LF . TAB.
			'<script  src="<VAR:WSFRAMEWORK/>dhtmlx/dhtmlxCalendar/codebase/dhtmlxcalendar.js"></script>' . CR . LF . TAB.
			'<script type="text/javascript" src="<VAR:WSFRAMEWORK/>dhtmlx/grid/excells/dhtmlxgrid_excell_dhxcalendar.js"></script>' . CR . LF . TAB.
			'<script  src="<VAR:WSFRAMEWORK/>dhtmlx/grid/excells/dhtmlxgrid_excell_dhxcalendar.js"></script>' . CR . LF . TAB.
			'<link rel="STYLESHEET" type="text/css" href="<VAR:WSFRAMEWORK/>dhtmlx/dhtmlxCalendar/codebase/skins/dhtmlxcalendar_dhx_skyblue.css">' . CR . LF . TAB;
		}
		
		//-- Incluir DHMTLX Menu o Submenu
		if (preg_match('/DHTMLX.+MENU/', $mods)) {
			$links .= '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>dhtmlx/menu/dhtmlxmenu.js?_=' . time() . '"></script>' . CR . LF . TAB
				. '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>dhtmlx/menu/ext/dhtmlxmenu_ext.js"></script>' . CR . LF . TAB;
		}
		
		//-- Incluir CSS para DHTMLX Menu
		if (strpos($mods, 'DHTMLX_MENU') !== false) {
			$links .= '<link rel="stylesheet" type="text/css" href="<VAR:WSCSS/>dhtmlxmenu_dhx_custom.css"/>' . CR . LF . TAB;
			
			//-- Incluir controlador JS de menu
			if (file_exists(FS_MENU . 'menu.js')) {
				$links .= '<script type="text/javascript" src="<VAR:WSMENU/>menu.js?_=' . time() . '" charset="utf-8"></script>' . CR . LF . TAB;
			}
		}
		
		//-- Incluir CSS para DHTMLX SubMenu
		if (strpos($mods, 'DHTMLX_SUBMENU') !== false) {
			$links .= '<link rel="stylesheet" type="text/css" href="<VAR:WSCSS/>dhtmlxmenu_dhx_submenu.css"/>' . CR . LF . TAB;
		}
		
		//-- Incluir DHTMLX Grid
		if (strpos($mods, 'DHTMLX_GRID') !== false) {
			$links .= '<link rel="stylesheet" type="text/css" href="<VAR:WSFRAMEWORK/>dhtmlx/grid/dhtmlxgrid.css"/>' . CR . LF . TAB
				. '<link rel="stylesheet" type="text/css" href="<VAR:WSFRAMEWORK/>dhtmlx/grid/skins/dhtmlxgrid_dhx_blue.css"/>' . CR . LF . TAB
				. '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>dhtmlx/grid/dhtmlxgrid.js"></script>' . CR . LF . TAB
				. '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>dhtmlx/grid/dhtmlxgridcell.js"></script>' . CR . LF . TAB
				. '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>dhtmlx/grid/ext/dhtmlxgrid_json.js"></script>' . CR . LF . TAB
				. '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>dhtmlx/grid/ext/dhtmlxgrid_nxml.js"></script>' . CR . LF . TAB
				. '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>dhtmlx/grid/ext/dhtmlxgrid_filter.js"></script>' . CR . LF . TAB
				. '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>dhtmlx/grid/ext/dhtmlxgrid_math.js"></script>' . CR . LF . TAB;
		}
		
		//-- Incluir DHTMLX Windows
		if (strpos($mods, 'DHTMLX_WINDOWS') !== false) {
			$links .= '<link rel="stylesheet" type="text/css" href="<VAR:WSFRAMEWORK/>dhtmlx/windows/dhtmlxwindows.css"/>' . CR . LF . TAB
				. '<link rel="stylesheet" type="text/css" href="<VAR:WSFRAMEWORK/>dhtmlx/windows/skins/dhtmlxwindows_dhx_blue.css"/>' . CR . LF . TAB
				. '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>dhtmlx/windows/dhtmlxcontainer.js"></script>' . CR . LF . TAB
				. '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>dhtmlx/windows/dhtmlxwindows.js"></script>' . CR . LF . TAB;
		}
		
		//-- Incluir DHTMLX Accordion
		if (strpos($mods, 'DHTMLX_ACCORDION') !== false) {
			$links .= '<script src="<VAR:WSFRAMEWORK/>dhtmlx/accordion/dhtmlxaccordion.js"></script>' . CR . LF . TAB
				.'<link rel="stylesheet" type="text/css" href="<VAR:WSFRAMEWORK/>dhtmlx/accordion/skins/dhtmlxaccordion_dhx_black.css">' . CR . LF . TAB
				.'<script src="<VAR:WSFRAMEWORK/>dhtmlx/accordion/dhtmlxcontainer.js"></script>' . CR . LF . TAB;
		}
		
		//-- Incluir funciones de Alertas
		if (strpos($mods, 'ALERTS') !== false) {
			$links .= '<script src="<VAR:WSFRAMEWORK/>js/adviceAndDialogs/alerts.js"></script>' . CR . LF . TAB;
		}

		//-- Incluir JWindows
		if (strpos($mods, 'JWINDOWS') !== false) {
			$links .= '<script src="<VAR:WSFRAMEWORK/>jwindows/jwindows.js"></script>' . CR . LF . TAB;

			if (file_exists(FS_CSS	. 'jwindows.css')) {
				$links .= '<link href="<VAR:WSCSS/>jwindows.css" rel="stylesheet" type="text/css"/>' . CR . LF . TAB;
			} else {
				$links .= '<link rel="stylesheet" type="text/css" href="<VAR:WSFRAMEWORK/>jwindows/css/jwindows.css">' . CR . LF . TAB;
			}
		}

		$links .= '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>js/templateHelper.js?_=' . time() . '" charset="utf-8"></script>' . CR . LF . TAB;
		
		//-- Incluir JS de la toma de Foto de JPEGCam
		if (strpos($mods, 'JPEGCAM') !== false) {
		$links .= '<script type="text/javascript" src="<VAR:WSROOT/>js/webcam.js"> </script>' . CR . LF . TAB;
		}
		
		//-- Incluir swfUploader para la carga de documentos.
		if (strpos($mods, 'UPLOADDOCS') !== false) {
			$links .= '<link href="<VAR:WSFRAMEWORK/>css/uploader.css" rel="stylesheet" type="text/css"/>' . CR . LF . TAB;
			$links .= '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>swf_uploader/swfupload.js"> </script>' . CR . LF . TAB;
			$links .= '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>swf_uploader/handlers.js"> </script>' . CR . LF . TAB;
			$links .= '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>swf_uploader/initUploader.js"> </script>' . CR . LF . TAB;
		}
		
		//-- Incluir DHTMLX Vault
		$links .= '<link rel="stylesheet" type="text/css" href="<VAR:WSFRAMEWORK/>dhtmlx/dhtmlxVault/codebase/skins/dhtmlxvault_dhx_skyblue.css"/>' . CR . LF . TAB;
		$links .= '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>dhtmlx/dhtmlxVault/codebase/dhtmlxcommon.js"></script>' . CR . LF . TAB;
		$links .= '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>dhtmlx/dhtmlxVault/codebase/swfobject.js"></script>' . CR . LF . TAB;
		$links .= '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>dhtmlx/dhtmlxVault/codebase/dhtmlxvault.js"></script>' . CR . LF . TAB;

		//-- Incluir DHTMLX Combo
		$links .= '<link rel="stylesheet" type="text/css" href="<VAR:WSFRAMEWORK/>dhtmlx/dhtmlxCombo/codebase/dhtmlxcombo.css"/>' . CR . LF . TAB;
		$links .= '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>dhtmlx/dhtmlxCombo/codebase/dhtmlxcommon.js"></script>' . CR . LF . TAB;
		$links .= '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>dhtmlx/dhtmlxCombo/codebase/dhtmlxcombo.js"></script>' . CR . LF . TAB;
		
		
//		ESTILOS PARA TOUR WEB TOURIST
		$links .=
		'<script type="text/javascript" src="<VAR:WSFRAMEWORK/>js/jquery/tourist/underscore-1.4.4.js"></script>' . CR . LF . TAB
		. '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>js/jquery/tourist/backbone-1.0.0.js"></script>' . CR . LF . TAB
		. '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>js/jquery/tourist/tourist.js"></script>' . CR . LF . TAB		
		. '<link href="<VAR:WSCSS/>bootstrap.min.css" rel="stylesheet">' . CR . LF . TAB
		. '<link href="<VAR:WSCSS/>font-awesome.min.css" rel="stylesheet">' . CR . LF . TAB
		. '<link href="<VAR:WSCSS/>tourist.css" rel="stylesheet" type="text/css"/>' . CR . LF . TAB
		. '<script type="text/javascript" src="<VAR:WSFRAMEWORK/>js/jquery/tourist/jquery.blockUI.js"></script>' . CR . LF . TAB;

		//Load Tour Invoicing
//		$links .= '<script type="text/javascript" src="<VAR:WSAPP/>tourInvoicing/tour.js" charset="utf-8"></script>' . CR . LF . TAB;
				
		$data = preg_replace('/<HEAD:LINKS +include="(.*)"\/>/', $links, $data);
	}

	public function load($file = '')
	{
		if (empty($file)) {
			exit('M&eacute;todo <b>load()</b> requiere una cadena.');
		} elseif (! file_exists($file)) {
			exit("Archivo <b>$file</b> no encontrado.");
		} else {
			$_fileContent = file_get_contents($file);
			$this->_setHtmlHeadIncludes($_fileContent);
			$this->_pushTemplate($_fileContent);
			$this->setVar(
				array(
					'APPTITLE' => APP_TITLE,
					'APPCOPYRIGHT' => APP_COPYRIGHT,
					'WSROOT' => WS_ROOT,
					'WSFRAMEWORK' => WS_FRAMEWORK,
					'WSAPP' => WS_APP,
					'WSCSS' => WS_CSS,
					'UI_THEME' => UI_THEME,
					'WSMENU' => WS_MENU,
					'ACTIVEUSER_NAME' => $_SESSION['user']->nombre,
					'ACTIVEUSER_LASTLOGIN' => shortdate($_SESSION['user']->fecha_acceso),
					'MENU_URL' => encodeQueryString(array('do' => FS_MENU . 'loadMenu')),
					'URL_RANDOMIZE' => '?_=' . time()
				)
			);
			
			global $aTemplateVars;
			
			if (isset($aTemplateVars)) {
				$this->setVar($aTemplateVars);
			}
		}
	}

	public function loadFromString($str = '')
	{
		if (empty($str)) {
			exit('M&eacute;todp <b>loadFromString()</b> requiere una cadena no vac&iacute;a.');
		} else {
			$this->_pushTemplate($str);
		}
	}

	public function publish($return = false)
	{
		if ($this->_getTemplate()) {
			if ($return) {
				return $this->_getTemplate();
			} else {
				echo preg_replace("/(>\s+<)/", "><", $this->_getTemplate());
			}
		} else {
			exit('No se ha cargado ning&uacute;n template.');
		}
	}

	public function selectRadio($aTags, $data = '')
	{
	    if (! is_array($aTags)) {
			$aTags = array($aTags => $data);
		}

	    foreach ($aTags as $tag => $value) {
			
		    $_regexp = '/\<input.+type="radio".+name=".+\[' . $tag . '\]".+(value="' . $value . '")\s*\/\>/i';
		    $n = preg_match($_regexp, $this->_getTemplate(), $_matches);

		    if ($n > 0) {
				$_check = str_replace($_matches[1], $_matches[1] . ' checked', $_matches[0]);
				$this->_setTemplate(str_replace($_matches[0], $_check, $this->_getTemplate()));
		    }
	    }
	}

	public function selectCombo($aTags, $data = '')
	{
	    if (! is_array($aTags)) {
			$aTags = array($aTags => $data);
		}

	    foreach ($aTags as $tag => $value) {
		    $_regexp = '/\<select[^\>]+name="[^\>]+' . $tag . '\]"[^\>]*\>(?:(?:\r?\n\t*)?<option[^<]+<\/option>)*(?:\r?\n\t*)?<option[^>]+(value="' . $value . '")[^<]+<\/option>(?:(?:\r?\n\t*)?<option[^<]+<\/option>)*(?:\r?\n\t*)?<\/select>/i';
		    
			if(preg_match_all($_regexp, $this->_getTemplate(), $_matches ,PREG_SET_ORDER)){

				foreach ($_matches as $_match) {
					$_check = str_replace($_match[1], $_match[1] . ' selected', $_match[0]);
					$this->_setTemplate(str_replace($_match[0], $_check, $this->_getTemplate()));
				}

//				//-- Lineas para Debug de Busqueda de Expresiones
//				if ($tag == 'solicitud\]\[domicilio\]\[id_estado') {
//					debug($aTags, false);
//					debug($data, false);
//					debug($_regexp, false);
//					debug($_matches, false);
//					debug($this->_getTemplate());
//				}
			}
//		    if ($n > 0) {
//				$_check = str_replace($_matches[1], $_matches[1] . ' selected', $_matches[0]);
//				$this->_setTemplate(str_replace($_matches[0], $_check, $this->_getTemplate()));
//		    }
	    }
	}

	public function markCheckbox($id, $value)
	{
		$_regexp = '/\<input(?!.+\<input).+type="checkbox".+name=".+\[' . $id . '\]".+(value="' . $value . '")[^\/]*\/\>/i';
		$n = preg_match($_regexp, $this->_getTemplate(), $_matches);

		if ($n > 0) {
			$_check = str_replace($_matches[1], $_matches[1] . ' checked="checked"', $_matches[0]);
			$this->_setTemplate(str_replace($_matches[0], $_check, $this->_getTemplate()));
		}
	}

	public function setVar($aTags, $data = '')
	{
		if (! is_array($aTags)) {
			$aTags = array($aTags => $data);
		}
		
		foreach ($aTags as $tag => $value) {
			$_regexp = '/<VAR:' . $tag . '\x20*\/>|<VAR\x20+name="' . $tag . '"\x20*\/>/';
			$value = str_replace('$', '\$', $value);
			$this->_setTemplate(preg_replace($_regexp, $value, $this->_getTemplate()));
		}
	}

	public function getBlock($tag)
	{
		$_matches = array();
		$_regexp = '/<BLOCK:(' . $tag . ')>([\s\S]*?)<\/BLOCK:\1>/';
		
		if (preg_match($_regexp, $this->_getTemplate(), $_matches)) {
			$this->_pushBlock(array_pop($_matches));
			return true;
		} else {
			return false;
		}
	}

	public function appendBlock()
	{
		$_block = $this->_getBlock() . $this->_getTemplate();
		$this->_setBlock($_block);
		$this->_restoreBlock();
	}

	public function putBlock($tag)
	{
		$_regexp = '/<BLOCK:(' . $tag . ')>([\s\S]*?)<\/BLOCK:\1>/';
		$_block = str_replace('$', '\$' ,$this->_getBlock());
		$_template = $this->_popBlock();
		$this->_setTemplate(preg_replace($_regexp, $_block, $_template));
	}

	public function setBlock($str)
	{
		$this->_setBlock($str);
	}

	public function removeBlock($tag, $remove=true)
	{
		if (! $this->getBlock($tag)) return;

		if ($remove) {
			$this->setBlock('');
		} else {
			$this->appendBlock();
		}

		$this->putBlock($tag);
	}
}
?>
